This section covers how to configure the Side Bar which contains Tool Panels.
Configuring the Side Bar Copy Link
The Side Bar is configured using the grid property sideBar. The property takes multiple forms to allow easy configuration or more advanced configuration. The different forms for the sideBar property are as follows:
| Type | Description |
|---|---|
undefined / null | No Side Bar provided. |
boolean | Set to true to display the Side Bar with default configuration. |
string / string[] | Set to 'columns', 'filters' or 'filters-new' to display the Side Bar with just one of Columns, Filters or New Filters Tool Panels or an array of some or all of these values. |
SideBarDef(long form) | An object of type SideBarDef (explained below) to allow detailed configuration of the Side Bar. Use this to configure the provided Tool Panels (e.g. pass parameters to the columns or filters panel) or to include custom Tool Panels. |
Boolean Configuration Copy Link
The default Side Bar contains the Columns and Filters Tool Panels. To use the default Side Bar, set the grid property sideBar=true. The Columns panel will be open by default.
The default configuration doesn't allow customisation of the Tool Panels.
import {
ClientSideRowModelModule,
GridApi,
GridOptions,
ModuleRegistry,
NumberFilterModule,
TextFilterModule,
createGrid,
enableDevValidations,
} from "ag-grid-community";
import {
ColumnsToolPanelModule,
FiltersToolPanelModule,
PivotModule,
SetFilterModule,
} from "ag-grid-enterprise";
import { IOlympicData } from "./interfaces";
if (process.env.NODE_ENV !== "production") {
// Enable extended validations only for development
enableDevValidations();
}
ModuleRegistry.registerModules([
NumberFilterModule,
ClientSideRowModelModule,
ColumnsToolPanelModule,
FiltersToolPanelModule,
SetFilterModule,
PivotModule,
TextFilterModule,
]);
let gridApi: GridApi<IOlympicData>;
const gridOptions: GridOptions<IOlympicData> = {
columnDefs: [
{ field: "athlete", filter: "agTextColumnFilter", minWidth: 200 },
{ field: "age" },
{ field: "country", minWidth: 180 },
{ field: "year" },
{ field: "date", minWidth: 150 },
{ field: "gold" },
{ field: "silver" },
{ field: "bronze" },
{ field: "total" },
],
defaultColDef: {
flex: 1,
minWidth: 100,
// allow every column to be aggregated
enableValue: true,
// allow every column to be grouped
enableRowGroup: true,
// allow every column to be pivoted
enablePivot: true,
filter: true,
},
autoGroupColumnDef: {
minWidth: 200,
},
sideBar: true,
};
const gridDiv = document.querySelector<HTMLElement>("#myGrid")!;
gridApi = createGrid(gridDiv, gridOptions);
fetch("https://www.ag-grid.com/example-assets/olympic-winners.json")
.then((response) => response.json())
.then((data: IOlympicData[]) => gridApi!.setGridOption("rowData", data));
<div id="myGrid" style="height: 100%"></div>
export interface IOlympicData {
athlete: string,
age: number,
country: string,
year: number,
date: string,
sport: string,
gold: number,
silver: number,
bronze: number,
total: number
} String Configuration Copy Link
To display just one of the provided Tool Panels, set either sideBar='columns', sideBar='filters' or sideBar='filters-new'. This will display the desired item with default configuration. Alternatively pass some or all of these values as a string[], i.e sideBar=['columns','filters', 'filters-new'].
The example below demonstrates using the string configuration. Note the following:
- The grid property
sideBaris set to'filters'. - The Side Bar is displayed showing only the Filters panel.
import {
ClientSideRowModelModule,
GridApi,
GridOptions,
ModuleRegistry,
NumberFilterModule,
TextFilterModule,
createGrid,
enableDevValidations,
} from "ag-grid-community";
import {
ColumnsToolPanelModule,
FiltersToolPanelModule,
PivotModule,
SetFilterModule,
} from "ag-grid-enterprise";
import { IOlympicData } from "./interfaces";
if (process.env.NODE_ENV !== "production") {
// Enable extended validations only for development
enableDevValidations();
}
ModuleRegistry.registerModules([
NumberFilterModule,
ClientSideRowModelModule,
ColumnsToolPanelModule,
FiltersToolPanelModule,
SetFilterModule,
PivotModule,
TextFilterModule,
]);
let gridApi: GridApi<IOlympicData>;
const gridOptions: GridOptions<IOlympicData> = {
columnDefs: [
{ field: "athlete", filter: "agTextColumnFilter", minWidth: 200 },
{ field: "age" },
{ field: "country", minWidth: 180 },
{ field: "year" },
{ field: "date", minWidth: 150 },
{ field: "gold" },
{ field: "silver" },
{ field: "bronze" },
{ field: "total" },
],
defaultColDef: {
flex: 1,
minWidth: 100,
// allow every column to be aggregated
enableValue: true,
// allow every column to be grouped
enableRowGroup: true,
// allow every column to be pivoted
enablePivot: true,
filter: true,
},
sideBar: "filters",
};
const gridDiv = document.querySelector<HTMLElement>("#myGrid")!;
gridApi = createGrid(gridDiv, gridOptions);
fetch("https://www.ag-grid.com/example-assets/olympic-winners.json")
.then((response) => response.json())
.then((data: IOlympicData[]) => gridApi!.setGridOption("rowData", data));
<div id="myGrid" style="height: 100%"></div>
export interface IOlympicData {
athlete: string,
age: number,
country: string,
year: number,
date: string,
sport: string,
gold: number,
silver: number,
bronze: number,
total: number
} SideBarDef Configuration Copy Link
The previous configurations are shortcuts for the full fledged configuration using a SideBarDef object. For full control over the configuration, you must provide a SideBarDef object.
Properties available on the SideBarDef interface.
A list of all the panels to place in the side bar. The panels will be displayed in the provided order from top to bottom.
|
The panel (identified by ID) to open by default. If none specified, the side bar is initially displayed closed. |
To hide the side bar by default, set this to true. If left undefined the side bar will be shown. |
Sets the side bar position relative to the grid. |
To hide the side bar buttons by default set this to true. If left undefined the buttons will be shown. This is useful if you want to show a tool panel without showing the buttons. |
The toolPanels property follows the ToolPanelDef interface:
Properties available on the ToolPanelDef interface.
The unique ID for this panel. Used in the API and elsewhere to refer to the panel. |
The key used for localisation for displaying the label. The label is displayed in the tab button. |
The default label if labelKey is missing or does not map to valid text through localisation. |
The min width of the tool panel. |
The max width of the tool panel. |
The initial width of the tool panel. |
The key of the icon to be used as a graphical aid beside the label in the side bar. |
The tool panel component to use as the panel. The provided panels use components agColumnsToolPanel, agFiltersToolPanel and agNewFiltersToolPanel. To provide your own custom panel component, you reference it here.
|
Customise the parameters provided to the toolPanel component. |
DOM element to use as the parent for the tool panel to allow it to appear outside the grid. Set to null or omit the property for tool panel to appear inside the grid.
|
The following snippet shows configuring the Tool Panel using a SideBarDef object:
const gridOptions = {
sideBar: {
toolPanels: [
{
id: 'columns',
labelDefault: 'Columns',
labelKey: 'columns',
iconKey: 'columns',
toolPanel: 'agColumnsToolPanel',
minWidth: 225,
maxWidth: 225,
width: 225
},
{
id: 'filters',
labelDefault: 'Filters',
labelKey: 'filters',
iconKey: 'filter',
toolPanel: 'agFiltersToolPanel',
minWidth: 180,
maxWidth: 400,
width: 250
}
],
position: 'left',
defaultToolPanel: 'filters',
},
// other grid options ...
}The snippet above is demonstrated in the following example:
import {
ClientSideRowModelModule,
GridApi,
GridOptions,
ModuleRegistry,
NumberFilterModule,
TextFilterModule,
createGrid,
enableDevValidations,
} from "ag-grid-community";
import {
ColumnsToolPanelModule,
FiltersToolPanelModule,
PivotModule,
SetFilterModule,
} from "ag-grid-enterprise";
import { IOlympicData } from "./interfaces";
if (process.env.NODE_ENV !== "production") {
// Enable extended validations only for development
enableDevValidations();
}
ModuleRegistry.registerModules([
NumberFilterModule,
ClientSideRowModelModule,
ColumnsToolPanelModule,
FiltersToolPanelModule,
SetFilterModule,
PivotModule,
TextFilterModule,
]);
let gridApi: GridApi<IOlympicData>;
const gridOptions: GridOptions<IOlympicData> = {
columnDefs: [
{ field: "athlete", filter: "agTextColumnFilter", minWidth: 200 },
{ field: "age" },
{ field: "country", minWidth: 180 },
{ field: "year" },
{ field: "date", minWidth: 150 },
{ field: "gold" },
{ field: "silver" },
{ field: "bronze" },
{ field: "total" },
],
defaultColDef: {
flex: 1,
minWidth: 100,
// allow every column to be aggregated
enableValue: true,
// allow every column to be grouped
enableRowGroup: true,
// allow every column to be pivoted
enablePivot: true,
filter: true,
},
autoGroupColumnDef: {
minWidth: 200,
},
sideBar: {
toolPanels: [
{
id: "columns",
labelDefault: "Columns",
labelKey: "columns",
iconKey: "columns",
toolPanel: "agColumnsToolPanel",
minWidth: 225,
width: 225,
maxWidth: 225,
},
{
id: "filters",
labelDefault: "Filters",
labelKey: "filters",
iconKey: "filter",
toolPanel: "agFiltersToolPanel",
minWidth: 180,
maxWidth: 400,
width: 250,
},
],
position: "left",
defaultToolPanel: "filters",
},
};
const gridDiv = document.querySelector<HTMLElement>("#myGrid")!;
gridApi = createGrid(gridDiv, gridOptions);
fetch("https://www.ag-grid.com/example-assets/olympic-winners.json")
.then((response) => response.json())
.then((data: IOlympicData[]) => gridApi!.setGridOption("rowData", data));
<div id="myGrid" style="height: 100%"></div>
export interface IOlympicData {
athlete: string,
age: number,
country: string,
year: number,
date: string,
sport: string,
gold: number,
silver: number,
bronze: number,
total: number
} Calling setSideBarVisible(true) when sideBarDef.hideButtons is set to true and no tool panel is open will not display anything.
The Popup Parent must be set to an element that contains both the tool panel parent and the grid to ensure all popups (e.g., Columns Tool Panel context menus) are fully visible.
Configuration Shortcuts Copy Link
The boolean and string configurations are shortcuts for more detailed configurations. When you use a shortcut the grid replaces it with the equivalent long form of the configuration by building the equivalent SideBarDef.
The following code snippets show an example of the boolean shortcut and the equivalent SideBarDef long form.
const gridOptions = {
// shortcut
sideBar: true,
// other grid options ...
}const gridOptions = {
// equivalent detailed long form
sideBar: {
toolPanels: [
{
id: 'columns',
labelDefault: 'Columns',
labelKey: 'columns',
iconKey: 'columns',
toolPanel: 'agColumnsToolPanel',
},
{
id: 'filters',
labelDefault: 'Filters',
labelKey: 'filters',
iconKey: 'filter',
toolPanel: 'agFiltersToolPanel',
}
],
defaultToolPanel: 'columns',
},
// other grid options ...
}The following code snippets show an example of the string shortcut and the equivalent SideBarDef long form.
const gridOptions = {
// shortcut
sideBar: 'filters',
// other grid options ...
}const gridOptions = {
// equivalent detailed long form
sideBar: {
toolPanels: [
{
id: 'filters',
labelDefault: 'Filters',
labelKey: 'filters',
iconKey: 'filter',
toolPanel: 'agFiltersToolPanel',
}
],
defaultToolPanel: 'filters',
},
// other grid options ...
}You can also use shortcuts inside the sideBar.toolPanels array for specifying the Columns and Filters items.
const gridOptions = {
// shortcut
sideBar: {
toolPanels: ['columns', 'filters']
},
// other grid options ...
}const gridOptions = {
// equivalent detailed long form
sideBar: {
toolPanels: [
{
id: 'columns',
labelDefault: 'Columns',
labelKey: 'columns',
iconKey: 'columns',
toolPanel: 'agColumnsToolPanel',
},
{
id: 'filters',
labelDefault: 'Filters',
labelKey: 'filters',
iconKey: 'filter',
toolPanel: 'agFiltersToolPanel',
}
]
},
// other grid options ...
} Side Bar Customisation Copy Link
If you are using the long form (providing a SideBarDef object) then it is possible to customise. The example below changes the filter label and icon.
import {
ClientSideRowModelModule,
GridApi,
GridOptions,
ModuleRegistry,
NumberFilterModule,
TextFilterModule,
createGrid,
enableDevValidations,
} from "ag-grid-community";
import {
ColumnsToolPanelModule,
FiltersToolPanelModule,
PivotModule,
SetFilterModule,
} from "ag-grid-enterprise";
import { IOlympicData } from "./interfaces";
if (process.env.NODE_ENV !== "production") {
// Enable extended validations only for development
enableDevValidations();
}
ModuleRegistry.registerModules([
NumberFilterModule,
ClientSideRowModelModule,
ColumnsToolPanelModule,
FiltersToolPanelModule,
SetFilterModule,
PivotModule,
TextFilterModule,
]);
let gridApi: GridApi<IOlympicData>;
const gridOptions: GridOptions<IOlympicData> = {
columnDefs: [
{ field: "athlete", filter: "agTextColumnFilter", minWidth: 200 },
{ field: "age" },
{ field: "country", minWidth: 180 },
{ field: "year" },
{ field: "date", minWidth: 150 },
{ field: "gold" },
{ field: "silver" },
{ field: "bronze" },
{ field: "total" },
],
defaultColDef: {
flex: 1,
minWidth: 100,
// allow every column to be aggregated
enableValue: true,
// allow every column to be grouped
enableRowGroup: true,
// allow every column to be pivoted
enablePivot: true,
filter: true,
},
autoGroupColumnDef: {
minWidth: 200,
},
sideBar: {
toolPanels: [
"columns",
{
id: "filters",
labelKey: "filters",
labelDefault: "Filters",
iconKey: "menu",
toolPanel: "agFiltersToolPanel",
},
{
id: "filters 2",
labelKey: "filters",
labelDefault: "Filters XXXXXXXX",
iconKey: "filter",
toolPanel: "agFiltersToolPanel",
},
],
defaultToolPanel: "filters",
},
};
const gridDiv = document.querySelector<HTMLElement>("#myGrid")!;
gridApi = createGrid(gridDiv, gridOptions);
fetch("https://www.ag-grid.com/example-assets/olympic-winners.json")
.then((response) => response.json())
.then((data: IOlympicData[]) => gridApi!.setGridOption("rowData", data));
<div id="myGrid" style="height: 100%"></div>
export interface IOlympicData {
athlete: string,
age: number,
country: string,
year: number,
date: string,
sport: string,
gold: number,
silver: number,
bronze: number,
total: number
} Tool Panel Parent Copy Link
By default, Tool Panels are rendered inside the Side Bar. If you want to render Tool Panels in a different location, you can set the parent property in the ToolPanelDef. This is useful if you want to render Tool Panel in a different part of your application, such as a popup window or a separate section of your page.
To ensure correct panel sizing, AG Grid adds a CSS class to the parent element. If your component also sets the parent class it may overwrite this, so include the ag-tool-panel-external class when setting the parent class:
<div id="toolPanelParent" class="your-app-class ag-tool-panel-external"></div>The Popup Parent must also be set to an element that contains both the Tool Panel parent and the grid.
You can also provide a parent for the tool panel in the call to openToolPanel method:
Opens a particular tool panel. Provide the ID of the tool panel to open.
Optionally, provide a parent element to attach the tool panel to. |
import {
ClientSideRowModelModule,
GridApi,
GridOptions,
ModuleRegistry,
NumberFilterModule,
TextFilterModule,
ToolPanelDef,
createGrid,
enableDevValidations,
} from "ag-grid-community";
import {
ColumnsToolPanelModule,
NewFiltersToolPanelModule,
PivotModule,
SetFilterModule,
} from "ag-grid-enterprise";
import { IOlympicData } from "./interfaces";
if (process.env.NODE_ENV !== "production") {
// Enable extended validations only for development
enableDevValidations();
}
ModuleRegistry.registerModules([
NumberFilterModule,
ClientSideRowModelModule,
ColumnsToolPanelModule,
NewFiltersToolPanelModule,
SetFilterModule,
PivotModule,
TextFilterModule,
]);
let gridApi: GridApi<IOlympicData>;
const columnsToolPanel: ToolPanelDef = {
id: "columns",
labelDefault: "Popup",
labelKey: "columns",
iconKey: "columnsToolPanel",
toolPanel: "agColumnsToolPanel",
toolPanelParams: {
suppressRowGroups: true,
suppressValues: true,
suppressPivotMode: true,
},
parent: document.querySelector("#popup .content"),
};
const filtersToolPanel: ToolPanelDef = {
id: "filters",
labelDefault: "Drawer",
labelKey: "filters",
iconKey: "filter",
toolPanel: "agNewFiltersToolPanel",
};
const gridOptions: GridOptions<IOlympicData> = {
popupParent: document.body,
columnDefs: [
{ field: "athlete", filter: "agTextColumnFilter", minWidth: 200 },
{ field: "country", minWidth: 180 },
{ field: "date", minWidth: 150 },
{ field: "gold", minWidth: 150 },
{ field: "silver", minWidth: 150 },
],
enableFilterHandlers: true,
defaultColDef: { flex: 1, minWidth: 100, filter: true },
autoGroupColumnDef: { minWidth: 200 },
sideBar: {
toolPanels: [columnsToolPanel, filtersToolPanel],
hideButtons: true,
hiddenByDefault: true,
},
};
function closePopup() {
const drawer = document.getElementById("popup");
drawer.classList.toggle("active", false);
gridApi.closeToolPanel();
}
function closeDrawer() {
const drawer = document.getElementById("drawer");
drawer.classList.toggle("active", false);
gridApi.closeToolPanel();
}
function openPopup() {
closeDrawer();
const popup = document.getElementById("popup")!;
popup.classList.toggle("active", true);
gridApi.openToolPanel(columnsToolPanel.id);
}
function openDrawer() {
closePopup();
const drawer = document.getElementById("drawer")!;
drawer.classList.toggle("active", true);
gridApi.openToolPanel(filtersToolPanel.id, drawer.querySelector(".content"));
}
const gridDiv = document.querySelector<HTMLElement>("#myGrid")!;
gridApi = createGrid(gridDiv, gridOptions);
fetch("https://www.ag-grid.com/example-assets/olympic-winners.json")
.then((response) => response.json())
.then((data: IOlympicData[]) => gridApi!.setGridOption("rowData", data));
if (typeof window !== "undefined") {
// Attach external event handlers to window so they can be called from index.html
(<any>window).closePopup = closePopup;
(<any>window).closeDrawer = closeDrawer;
(<any>window).openPopup = openPopup;
(<any>window).openDrawer = openDrawer;
}
.example-wrapper {
display: flex;
flex-direction: column;
height: 100%;
}
#myGrid {
flex: 1 1 0;
width: 100%;
}
.example-header {
margin-bottom: 10px;
}
#drawer.active,
#popup.active {
display: flex;
}
/* Base styles for the container */
#popup {
display: none; /* Hidden by default */
position: absolute;
top: 50%;
left: 50%;
transform: translate(-50%, -50%);
& .inner {
min-width: 300px;
}
& .content {
min-height: 200px;
}
}
#popup .inner {
border: 1px solid;
padding: 20px;
border-radius: 10px;
-webkit-font-smoothing: antialiased;
background-color: var(--example-background-color, white);
color: var(--example-text-color, black);
color-scheme: var(--example-color-scheme);
font-family: var(--example-font-family, Arial), sans-serif;
flex-direction: column;
}
/* Base styles for the container */
#drawer {
& .inner {
min-width: 300px;
}
& .content {
min-height: 200px;
}
position: fixed;
z-index: 2;
top: 54px;
bottom: 0;
width: 300px;
display: flex;
transform: translateX(-344px);
transition: transform 0.3s ease-in-out;
}
#drawer .content {
height: calc(100% - 90px);
}
#drawer .inner {
border: 1px solid;
padding: 20px;
border-radius: 10px;
-webkit-font-smoothing: antialiased;
background-color: var(--example-background-color, white);
color: var(--example-text-color, black);
color-scheme: var(--example-color-scheme);
font-family: var(--example-font-family, Arial), sans-serif;
flex-direction: column;
}
#drawer.active {
transform: translateX(0);
}
<div id="wrapper" class="example-wrapper">
<div class="example-header">
<button onclick="openPopup()">Open Columns Tool Panel</button>
<button onclick="openDrawer()">Open Filters Tool Panel</button>
</div>
<div id="myGrid"></div>
</div>
<div id="popup">
<div class="inner">
<div><button onclick="closePopup()">Close</button></div>
<div class="content"></div>
</div>
</div>
<div id="drawer">
<div class="inner">
<div><button onclick="closeDrawer()">Close</button></div>
<div class="content"></div>
</div>
</div>
export interface IOlympicData {
athlete: string,
age: number,
country: string,
year: number,
date: string,
sport: string,
gold: number,
silver: number,
bronze: number,
total: number
} Providing Parameters to Tool Panels Copy Link
Parameters are passed to Tool Panels via the toolPanelParams object. For example, the following code snippet sets suppressRowGroups: true and suppressValues: true for the Columns Tool Panel.
const gridOptions = {
sideBar: {
toolPanels: [
{
id: 'columns',
labelDefault: 'Columns',
labelKey: 'columns',
iconKey: 'columns',
toolPanel: 'agColumnsToolPanel',
toolPanelParams: {
suppressRowGroups: true,
suppressValues: true,
}
}
]
},
// other grid options ...
}See the Columns Tool Panel documentation for the full list of possible parameters to this Tool Panel.
Animation Copy Link
By default, sidebar panels open and close instantly. You can enable a smooth slide animation using the Theming API parameter sideBarPanelAnimationDuration. Set it to a value in seconds:
const myTheme = themeQuartz.withParams({
sideBarPanelAnimationDuration: 0.3,
});The animation is automatically disabled for users who have requested reduced motion in their OS accessibility settings.
import {
ClientSideRowModelModule,
ColDef,
GridApi,
GridOptions,
ModuleRegistry,
NumberFilterModule,
TextFilterModule,
createGrid,
enableDevValidations,
themeQuartz,
} from "ag-grid-community";
import {
ColumnsToolPanelModule,
NewFiltersToolPanelModule,
PivotModule,
SideBarModule,
} from "ag-grid-enterprise";
import { IOlympicData } from "./interfaces";
if (process.env.NODE_ENV !== "production") {
// Enable extended validations only for development
enableDevValidations();
}
ModuleRegistry.registerModules([
ClientSideRowModelModule,
ColumnsToolPanelModule,
NewFiltersToolPanelModule,
TextFilterModule,
NumberFilterModule,
SideBarModule,
PivotModule,
]);
const myTheme = themeQuartz.withParams({
sideBarPanelAnimationDuration: 0.3,
});
const columnDefs: ColDef[] = [
{ field: "athlete" },
{ field: "country" },
{ field: "sport" },
{ field: "year" },
];
let gridApi: GridApi<IOlympicData>;
const gridOptions: GridOptions<IOlympicData> = {
theme: myTheme,
columnDefs: columnDefs,
defaultColDef: {
flex: 1,
filter: true,
sortable: true,
resizable: true,
},
enableFilterHandlers: true,
sideBar: ["columns", "filters-new"],
};
const gridDiv = document.querySelector<HTMLElement>("#myGrid")!;
gridApi = createGrid(gridDiv, gridOptions);
fetch("https://www.ag-grid.com/example-assets/olympic-winners.json")
.then((response) => response.json())
.then((data: IOlympicData[]) => gridApi!.setGridOption("rowData", data));
<div id="myGrid" style="height: 100%"></div>
export interface IOlympicData {
athlete: string,
age: number,
country: string,
year: number,
date: string,
sport: string,
gold: number,
silver: number,
bronze: number,
total: number
} Side Bar API Copy Link
The Side Bar state can be saved and restored as part of Grid State.
The list below details all the API methods relevant to the Tool Panel.
Returns the current side bar configuration. If a shortcut was used, returns the detailed long form. |
Show/hide the entire side bar, including any visible panel and the tab buttons. |
Returns true if the side bar is visible. |
Sets the side bar position relative to the grid. Possible values are 'left' or 'right'. |
Opens a particular tool panel. Provide the ID of the tool panel to open.
Optionally, provide a parent element to attach the tool panel to. |
Closes the currently open tool panel (if any). |
Returns the ID of the currently shown tool panel if any, otherwise null. |
Returns true if the tool panel is showing, otherwise false. |
Force refreshes all tool panels by calling their refresh method. |
Gets the tool panel instance corresponding to the supplied id. |
The example below demonstrates different usages of the Tool Panel API methods. The following can be noted:
- Initially the Side Bar is not visible as
sideBar.hiddenByDefault=true. - Visibility Buttons: These toggle visibility of the Tool Panel. Note that when you make
visible=false, the entire Tool Panel is hidden including the tabs. Make sure the Tool Panel is left visible before testing the other API features so you can see the impact. - Open / Close Buttons: These open and close different Tool Panel items.
- Reset Buttons: These reset the Tool Panel to a new configuration. Notice that shortcuts are provided as configuration however
getSideBar()returns back the long form. - Position Buttons: These change the position of the Side Bar relative to the grid.
- The
get*buttons log data to the developer console.
import {
ClientSideRowModelModule,
GridApi,
GridOptions,
ModuleRegistry,
NumberFilterModule,
SideBarDef,
TextFilterModule,
ToolPanelSizeChangedEvent,
ToolPanelVisibleChangedEvent,
createGrid,
enableDevValidations,
} from "ag-grid-community";
import {
ColumnsToolPanelModule,
FiltersToolPanelModule,
PivotModule,
SetFilterModule,
} from "ag-grid-enterprise";
import { IOlympicData } from "./interfaces";
if (process.env.NODE_ENV !== "production") {
// Enable extended validations only for development
enableDevValidations();
}
ModuleRegistry.registerModules([
NumberFilterModule,
ClientSideRowModelModule,
ColumnsToolPanelModule,
FiltersToolPanelModule,
SetFilterModule,
PivotModule,
TextFilterModule,
]);
let gridApi: GridApi<IOlympicData>;
const gridOptions: GridOptions<IOlympicData> = {
columnDefs: [
{ field: "athlete", filter: "agTextColumnFilter", minWidth: 200 },
{ field: "age" },
{ field: "country", minWidth: 200 },
{ field: "year" },
{ field: "date", minWidth: 160 },
{ field: "gold" },
{ field: "silver" },
{ field: "bronze" },
{ field: "total" },
],
defaultColDef: {
flex: 1,
minWidth: 100,
// allow every column to be aggregated
enableValue: true,
// allow every column to be grouped
enableRowGroup: true,
// allow every column to be pivoted
enablePivot: true,
filter: true,
},
autoGroupColumnDef: {
minWidth: 200,
},
sideBar: {
toolPanels: [
{
id: "columns",
labelDefault: "Columns",
labelKey: "columns",
iconKey: "columns",
toolPanel: "agColumnsToolPanel",
},
{
id: "filters",
labelDefault: "Filters",
labelKey: "filters",
iconKey: "filter",
toolPanel: "agFiltersToolPanel",
},
],
defaultToolPanel: "filters",
hiddenByDefault: true,
},
onToolPanelVisibleChanged: (event: ToolPanelVisibleChangedEvent) => {
console.log("toolPanelVisibleChanged", event);
},
onToolPanelSizeChanged: (event: ToolPanelSizeChangedEvent) => {
console.log("toolPanelSizeChanged", event);
},
};
function setSideBarVisible(value: boolean) {
gridApi!.setSideBarVisible(value);
}
function isSideBarVisible() {
console.log(gridApi!.isSideBarVisible());
}
function openToolPanel(key: string) {
gridApi!.openToolPanel(key);
}
function closeToolPanel() {
gridApi!.closeToolPanel();
}
function getOpenedToolPanel() {
console.log(gridApi!.getOpenedToolPanel());
}
function setSideBar(def: SideBarDef | string | string[] | boolean) {
gridApi!.setGridOption("sideBar", def);
}
function getSideBar() {
const sideBar = gridApi!.getSideBar();
console.log(JSON.stringify(sideBar));
console.log(sideBar);
}
function setSideBarPosition(position: "left" | "right") {
gridApi!.setSideBarPosition(position);
}
const gridDiv = document.querySelector<HTMLElement>("#myGrid")!;
gridApi = createGrid(gridDiv, gridOptions);
fetch("https://www.ag-grid.com/example-assets/olympic-winners.json")
.then((response) => response.json())
.then((data: IOlympicData[]) => gridApi!.setGridOption("rowData", data));
if (typeof window !== "undefined") {
// Attach external event handlers to window so they can be called from index.html
(<any>window).setSideBarVisible = setSideBarVisible;
(<any>window).isSideBarVisible = isSideBarVisible;
(<any>window).openToolPanel = openToolPanel;
(<any>window).closeToolPanel = closeToolPanel;
(<any>window).getOpenedToolPanel = getOpenedToolPanel;
(<any>window).setSideBar = setSideBar;
(<any>window).getSideBar = getSideBar;
(<any>window).setSideBarPosition = setSideBarPosition;
}
.api-panel {
display: flex;
flex-direction: row;
flex-wrap: wrap;
font-family: Verdana, Geneva, Tahoma, sans-serif;
font-size: 13px;
}
.api-column {
padding: 0px 5px 5px;
text-align: center;
width: 215px;
max-height: 200px;
}
.api-column button {
width: 100%;
}
.api-column button:first-child {
margin-top: 5px;
}
.api-panel button {
margin: 2px;
}
.grid-div {
height: 100%;
}
.parent-div {
height: 100%;
display: grid;
grid-template-rows: auto 1fr;
}
<div class="parent-div">
<div class="api-panel">
<div class="api-column">
Visibility
<button onclick="setSideBarVisible(true)">setSideBarVisible(true)</button>
<button onclick="setSideBarVisible(false)">setSideBarVisible(false)</button>
<button onclick="isSideBarVisible()">isSideBarVisible()</button>
</div>
<div class="api-column">
Open & Close
<button onclick="openToolPanel('columns')">openToolPanel('columns')</button>
<button onclick="openToolPanel('filters')">openToolPanel('filters')</button>
<button onclick="closeToolPanel()">closeToolPanel()</button>
<button onclick="getOpenedToolPanel()">getOpenedToolPanel()</button>
</div>
<div class="api-column">
Reset
<button onclick="setSideBar(['filters', 'columns'])">setSideBar(['filters','columns'])</button>
<button onclick="setSideBar('columns')">setSideBar('columns')</button>
<button onclick="getSideBar()">getSideBar()</button>
</div>
<div class="api-column">
Position
<button onclick="setSideBarPosition('left')">setSideBarPosition('left')</button>
<button onclick="setSideBarPosition('right')">setSideBarPosition('right')</button>
</div>
</div>
<div id="myGrid" class="grid-div"></div>
</div>
export interface IOlympicData {
athlete: string,
age: number,
country: string,
year: number,
date: string,
sport: string,
gold: number,
silver: number,
bronze: number,
total: number
}

This section covers how to configure the Side Bar which contains Tool Panels.
Configuring the Side Bar Copy Link
The Side Bar is configured using the grid property sideBar. The property takes multiple forms to allow easy configuration or more advanced configuration. The different forms for the sideBar property are as follows:
| Type | Description |
|---|---|
undefined / null | No Side Bar provided. |
boolean | Set to true to display the Side Bar with default configuration. |
string / string[] | Set to 'columns', 'filters' or 'filters-new' to display the Side Bar with just one of Columns, Filters or New Filters Tool Panels or an array of some or all of these values. |
SideBarDef(long form) | An object of type SideBarDef (explained below) to allow detailed configuration of the Side Bar. Use this to configure the provided Tool Panels (e.g. pass parameters to the columns or filters panel) or to include custom Tool Panels. |
Boolean Configuration Copy Link
The default Side Bar contains the Columns and Filters Tool Panels. To use the default Side Bar, set the grid property sideBar=true. The Columns panel will be open by default.
The default configuration doesn't allow customisation of the Tool Panels.
import {
createApp,
defineComponent,
onBeforeMount,
ref,
shallowRef,
} from "vue";
import { AgGridVue } from "ag-grid-vue3";
import {
AutoGroupColumnDef,
ClientSideRowModelModule,
ColDef,
ColGroupDef,
GridApi,
GridOptions,
GridReadyEvent,
ModuleRegistry,
NumberFilterModule,
SideBarDef,
TextFilterModule,
enableDevValidations,
} from "ag-grid-community";
import {
ColumnsToolPanelModule,
FiltersToolPanelModule,
PivotModule,
SetFilterModule,
} from "ag-grid-enterprise";
import { IOlympicData } from "./interfaces";
if (process.env.NODE_ENV !== "production") {
// Enable extended validations only for development
enableDevValidations();
}
ModuleRegistry.registerModules([
NumberFilterModule,
ClientSideRowModelModule,
ColumnsToolPanelModule,
FiltersToolPanelModule,
SetFilterModule,
PivotModule,
TextFilterModule,
]);
const VueExample = defineComponent({
template: `
<div style="height: 100%">
<ag-grid-vue
style="width: 100%; height: 100%;"
@grid-ready="onGridReady"
:columnDefs="columnDefs"
:defaultColDef="defaultColDef"
:autoGroupColumnDef="autoGroupColumnDef"
:sideBar="true"
:rowData="rowData"></ag-grid-vue>
</div>
`,
components: {
"ag-grid-vue": AgGridVue,
},
setup(props) {
const gridApi = shallowRef<GridApi<IOlympicData> | null>(null);
const columnDefs = ref<ColDef[]>([
{ field: "athlete", filter: "agTextColumnFilter", minWidth: 200 },
{ field: "age" },
{ field: "country", minWidth: 180 },
{ field: "year" },
{ field: "date", minWidth: 150 },
{ field: "gold" },
{ field: "silver" },
{ field: "bronze" },
{ field: "total" },
]);
const defaultColDef = ref<ColDef>({
flex: 1,
minWidth: 100,
// allow every column to be aggregated
enableValue: true,
// allow every column to be grouped
enableRowGroup: true,
// allow every column to be pivoted
enablePivot: true,
filter: true,
});
const autoGroupColumnDef = ref<AutoGroupColumnDef>({
minWidth: 200,
});
const rowData = ref<IOlympicData[]>(null);
const onGridReady = (params: GridReadyEvent) => {
gridApi.value = params.api;
const updateData = (data) => (rowData.value = data);
fetch("https://www.ag-grid.com/example-assets/olympic-winners.json")
.then((resp) => resp.json())
.then((data) => updateData(data));
};
return {
gridApi,
columnDefs,
defaultColDef,
autoGroupColumnDef,
rowData,
onGridReady,
};
},
});
const app = createApp(VueExample);
app.mount("#app");
String Configuration Copy Link
To display just one of the provided Tool Panels, set either sideBar='columns', sideBar='filters' or sideBar='filters-new'. This will display the desired item with default configuration. Alternatively pass some or all of these values as a string[], i.e sideBar=['columns','filters', 'filters-new'].
The example below demonstrates using the string configuration. Note the following:
- The grid property
sideBaris set to'filters'. - The Side Bar is displayed showing only the Filters panel.
import {
createApp,
defineComponent,
onBeforeMount,
ref,
shallowRef,
} from "vue";
import { AgGridVue } from "ag-grid-vue3";
import {
ClientSideRowModelModule,
ColDef,
ColGroupDef,
GridApi,
GridOptions,
GridReadyEvent,
ModuleRegistry,
NumberFilterModule,
SideBarDef,
TextFilterModule,
enableDevValidations,
} from "ag-grid-community";
import {
ColumnsToolPanelModule,
FiltersToolPanelModule,
PivotModule,
SetFilterModule,
} from "ag-grid-enterprise";
import { IOlympicData } from "./interfaces";
if (process.env.NODE_ENV !== "production") {
// Enable extended validations only for development
enableDevValidations();
}
ModuleRegistry.registerModules([
NumberFilterModule,
ClientSideRowModelModule,
ColumnsToolPanelModule,
FiltersToolPanelModule,
SetFilterModule,
PivotModule,
TextFilterModule,
]);
const VueExample = defineComponent({
template: `
<div style="height: 100%">
<ag-grid-vue
style="width: 100%; height: 100%;"
@grid-ready="onGridReady"
:columnDefs="columnDefs"
:defaultColDef="defaultColDef"
:sideBar="sideBar"
:rowData="rowData"></ag-grid-vue>
</div>
`,
components: {
"ag-grid-vue": AgGridVue,
},
setup(props) {
const gridApi = shallowRef<GridApi<IOlympicData> | null>(null);
const columnDefs = ref<ColDef[]>([
{ field: "athlete", filter: "agTextColumnFilter", minWidth: 200 },
{ field: "age" },
{ field: "country", minWidth: 180 },
{ field: "year" },
{ field: "date", minWidth: 150 },
{ field: "gold" },
{ field: "silver" },
{ field: "bronze" },
{ field: "total" },
]);
const defaultColDef = ref<ColDef>({
flex: 1,
minWidth: 100,
// allow every column to be aggregated
enableValue: true,
// allow every column to be grouped
enableRowGroup: true,
// allow every column to be pivoted
enablePivot: true,
filter: true,
});
const sideBar = ref<SideBarDef | string | string[] | boolean | null>(
"filters",
);
const rowData = ref<IOlympicData[]>(null);
const onGridReady = (params: GridReadyEvent) => {
gridApi.value = params.api;
const updateData = (data) => (rowData.value = data);
fetch("https://www.ag-grid.com/example-assets/olympic-winners.json")
.then((resp) => resp.json())
.then((data) => updateData(data));
};
return {
gridApi,
columnDefs,
defaultColDef,
sideBar,
rowData,
onGridReady,
};
},
});
const app = createApp(VueExample);
app.mount("#app");
SideBarDef Configuration Copy Link
The previous configurations are shortcuts for the full fledged configuration using a SideBarDef object. For full control over the configuration, you must provide a SideBarDef object.
Properties available on the SideBarDef interface.
A list of all the panels to place in the side bar. The panels will be displayed in the provided order from top to bottom.
|
The panel (identified by ID) to open by default. If none specified, the side bar is initially displayed closed. |
To hide the side bar by default, set this to true. If left undefined the side bar will be shown. |
Sets the side bar position relative to the grid. |
To hide the side bar buttons by default set this to true. If left undefined the buttons will be shown. This is useful if you want to show a tool panel without showing the buttons. |
The toolPanels property follows the ToolPanelDef interface:
Properties available on the ToolPanelDef interface.
The unique ID for this panel. Used in the API and elsewhere to refer to the panel. |
The key used for localisation for displaying the label. The label is displayed in the tab button. |
The default label if labelKey is missing or does not map to valid text through localisation. |
The min width of the tool panel. |
The max width of the tool panel. |
The initial width of the tool panel. |
The key of the icon to be used as a graphical aid beside the label in the side bar. |
The tool panel component to use as the panel. The provided panels use components agColumnsToolPanel, agFiltersToolPanel and agNewFiltersToolPanel. To provide your own custom panel component, you reference it here.
|
Customise the parameters provided to the toolPanel component. |
DOM element to use as the parent for the tool panel to allow it to appear outside the grid. Set to null or omit the property for tool panel to appear inside the grid.
|
The following snippet shows configuring the Tool Panel using a SideBarDef object:
<ag-grid-vue
:sideBar="sideBar"
/* other grid options ... */>
</ag-grid-vue>
this.sideBar = {
toolPanels: [
{
id: 'columns',
labelDefault: 'Columns',
labelKey: 'columns',
iconKey: 'columns',
toolPanel: 'agColumnsToolPanel',
minWidth: 225,
maxWidth: 225,
width: 225
},
{
id: 'filters',
labelDefault: 'Filters',
labelKey: 'filters',
iconKey: 'filter',
toolPanel: 'agFiltersToolPanel',
minWidth: 180,
maxWidth: 400,
width: 250
}
],
position: 'left',
defaultToolPanel: 'filters',
};The snippet above is demonstrated in the following example:
import {
createApp,
defineComponent,
onBeforeMount,
ref,
shallowRef,
} from "vue";
import { AgGridVue } from "ag-grid-vue3";
import {
AutoGroupColumnDef,
ClientSideRowModelModule,
ColDef,
ColGroupDef,
GridApi,
GridOptions,
GridReadyEvent,
ModuleRegistry,
NumberFilterModule,
SideBarDef,
TextFilterModule,
enableDevValidations,
} from "ag-grid-community";
import {
ColumnsToolPanelModule,
FiltersToolPanelModule,
PivotModule,
SetFilterModule,
} from "ag-grid-enterprise";
import { IOlympicData } from "./interfaces";
if (process.env.NODE_ENV !== "production") {
// Enable extended validations only for development
enableDevValidations();
}
ModuleRegistry.registerModules([
NumberFilterModule,
ClientSideRowModelModule,
ColumnsToolPanelModule,
FiltersToolPanelModule,
SetFilterModule,
PivotModule,
TextFilterModule,
]);
const VueExample = defineComponent({
template: `
<div style="height: 100%">
<ag-grid-vue
style="width: 100%; height: 100%;"
@grid-ready="onGridReady"
:columnDefs="columnDefs"
:defaultColDef="defaultColDef"
:autoGroupColumnDef="autoGroupColumnDef"
:sideBar="sideBar"
:rowData="rowData"></ag-grid-vue>
</div>
`,
components: {
"ag-grid-vue": AgGridVue,
},
setup(props) {
const gridApi = shallowRef<GridApi<IOlympicData> | null>(null);
const columnDefs = ref<ColDef[]>([
{ field: "athlete", filter: "agTextColumnFilter", minWidth: 200 },
{ field: "age" },
{ field: "country", minWidth: 180 },
{ field: "year" },
{ field: "date", minWidth: 150 },
{ field: "gold" },
{ field: "silver" },
{ field: "bronze" },
{ field: "total" },
]);
const defaultColDef = ref<ColDef>({
flex: 1,
minWidth: 100,
// allow every column to be aggregated
enableValue: true,
// allow every column to be grouped
enableRowGroup: true,
// allow every column to be pivoted
enablePivot: true,
filter: true,
});
const autoGroupColumnDef = ref<AutoGroupColumnDef>({
minWidth: 200,
});
const sideBar = ref<SideBarDef | string | string[] | boolean | null>({
toolPanels: [
{
id: "columns",
labelDefault: "Columns",
labelKey: "columns",
iconKey: "columns",
toolPanel: "agColumnsToolPanel",
minWidth: 225,
width: 225,
maxWidth: 225,
},
{
id: "filters",
labelDefault: "Filters",
labelKey: "filters",
iconKey: "filter",
toolPanel: "agFiltersToolPanel",
minWidth: 180,
maxWidth: 400,
width: 250,
},
],
position: "left",
defaultToolPanel: "filters",
});
const rowData = ref<IOlympicData[]>(null);
const onGridReady = (params: GridReadyEvent) => {
gridApi.value = params.api;
const updateData = (data) => (rowData.value = data);
fetch("https://www.ag-grid.com/example-assets/olympic-winners.json")
.then((resp) => resp.json())
.then((data) => updateData(data));
};
return {
gridApi,
columnDefs,
defaultColDef,
autoGroupColumnDef,
sideBar,
rowData,
onGridReady,
};
},
});
const app = createApp(VueExample);
app.mount("#app");
Calling setSideBarVisible(true) when sideBarDef.hideButtons is set to true and no tool panel is open will not display anything.
The Popup Parent must be set to an element that contains both the tool panel parent and the grid to ensure all popups (e.g., Columns Tool Panel context menus) are fully visible.
Configuration Shortcuts Copy Link
The boolean and string configurations are shortcuts for more detailed configurations. When you use a shortcut the grid replaces it with the equivalent long form of the configuration by building the equivalent SideBarDef.
The following code snippets show an example of the boolean shortcut and the equivalent SideBarDef long form.
<ag-grid-vue
:sideBar="sideBar"
/* other grid options ... */>
</ag-grid-vue>
// shortcut
this.sideBar = true;<ag-grid-vue
:sideBar="sideBar"
/* other grid options ... */>
</ag-grid-vue>
// equivalent detailed long form
this.sideBar = {
toolPanels: [
{
id: 'columns',
labelDefault: 'Columns',
labelKey: 'columns',
iconKey: 'columns',
toolPanel: 'agColumnsToolPanel',
},
{
id: 'filters',
labelDefault: 'Filters',
labelKey: 'filters',
iconKey: 'filter',
toolPanel: 'agFiltersToolPanel',
}
],
defaultToolPanel: 'columns',
};The following code snippets show an example of the string shortcut and the equivalent SideBarDef long form.
<ag-grid-vue
:sideBar="sideBar"
/* other grid options ... */>
</ag-grid-vue>
// shortcut
this.sideBar = 'filters';<ag-grid-vue
:sideBar="sideBar"
/* other grid options ... */>
</ag-grid-vue>
// equivalent detailed long form
this.sideBar = {
toolPanels: [
{
id: 'filters',
labelDefault: 'Filters',
labelKey: 'filters',
iconKey: 'filter',
toolPanel: 'agFiltersToolPanel',
}
],
defaultToolPanel: 'filters',
};You can also use shortcuts inside the sideBar.toolPanels array for specifying the Columns and Filters items.
<ag-grid-vue
:sideBar="sideBar"
/* other grid options ... */>
</ag-grid-vue>
// shortcut
this.sideBar = {
toolPanels: ['columns', 'filters']
};<ag-grid-vue
:sideBar="sideBar"
/* other grid options ... */>
</ag-grid-vue>
// equivalent detailed long form
this.sideBar = {
toolPanels: [
{
id: 'columns',
labelDefault: 'Columns',
labelKey: 'columns',
iconKey: 'columns',
toolPanel: 'agColumnsToolPanel',
},
{
id: 'filters',
labelDefault: 'Filters',
labelKey: 'filters',
iconKey: 'filter',
toolPanel: 'agFiltersToolPanel',
}
]
}; Side Bar Customisation Copy Link
If you are using the long form (providing a SideBarDef object) then it is possible to customise. The example below changes the filter label and icon.
import {
createApp,
defineComponent,
onBeforeMount,
ref,
shallowRef,
} from "vue";
import { AgGridVue } from "ag-grid-vue3";
import {
AutoGroupColumnDef,
ClientSideRowModelModule,
ColDef,
ColGroupDef,
GridApi,
GridOptions,
GridReadyEvent,
ModuleRegistry,
NumberFilterModule,
SideBarDef,
TextFilterModule,
enableDevValidations,
} from "ag-grid-community";
import {
ColumnsToolPanelModule,
FiltersToolPanelModule,
PivotModule,
SetFilterModule,
} from "ag-grid-enterprise";
import { IOlympicData } from "./interfaces";
if (process.env.NODE_ENV !== "production") {
// Enable extended validations only for development
enableDevValidations();
}
ModuleRegistry.registerModules([
NumberFilterModule,
ClientSideRowModelModule,
ColumnsToolPanelModule,
FiltersToolPanelModule,
SetFilterModule,
PivotModule,
TextFilterModule,
]);
const VueExample = defineComponent({
template: `
<div style="height: 100%">
<ag-grid-vue
style="width: 100%; height: 100%;"
@grid-ready="onGridReady"
:columnDefs="columnDefs"
:defaultColDef="defaultColDef"
:autoGroupColumnDef="autoGroupColumnDef"
:sideBar="sideBar"
:rowData="rowData"></ag-grid-vue>
</div>
`,
components: {
"ag-grid-vue": AgGridVue,
},
setup(props) {
const gridApi = shallowRef<GridApi<IOlympicData> | null>(null);
const columnDefs = ref<ColDef[]>([
{ field: "athlete", filter: "agTextColumnFilter", minWidth: 200 },
{ field: "age" },
{ field: "country", minWidth: 180 },
{ field: "year" },
{ field: "date", minWidth: 150 },
{ field: "gold" },
{ field: "silver" },
{ field: "bronze" },
{ field: "total" },
]);
const defaultColDef = ref<ColDef>({
flex: 1,
minWidth: 100,
// allow every column to be aggregated
enableValue: true,
// allow every column to be grouped
enableRowGroup: true,
// allow every column to be pivoted
enablePivot: true,
filter: true,
});
const autoGroupColumnDef = ref<AutoGroupColumnDef>({
minWidth: 200,
});
const sideBar = ref<SideBarDef | string | string[] | boolean | null>({
toolPanels: [
"columns",
{
id: "filters",
labelKey: "filters",
labelDefault: "Filters",
iconKey: "menu",
toolPanel: "agFiltersToolPanel",
},
{
id: "filters 2",
labelKey: "filters",
labelDefault: "Filters XXXXXXXX",
iconKey: "filter",
toolPanel: "agFiltersToolPanel",
},
],
defaultToolPanel: "filters",
});
const rowData = ref<IOlympicData[]>(null);
const onGridReady = (params: GridReadyEvent) => {
gridApi.value = params.api;
const updateData = (data) => (rowData.value = data);
fetch("https://www.ag-grid.com/example-assets/olympic-winners.json")
.then((resp) => resp.json())
.then((data) => updateData(data));
};
return {
gridApi,
columnDefs,
defaultColDef,
autoGroupColumnDef,
sideBar,
rowData,
onGridReady,
};
},
});
const app = createApp(VueExample);
app.mount("#app");
Tool Panel Parent Copy Link
By default, Tool Panels are rendered inside the Side Bar. If you want to render Tool Panels in a different location, you can set the parent property in the ToolPanelDef. This is useful if you want to render Tool Panel in a different part of your application, such as a popup window or a separate section of your page.
To ensure correct panel sizing, AG Grid adds a CSS class to the parent element. If your component also sets the parent class it may overwrite this, so include the ag-tool-panel-external class when setting the parent class:
<div ref="toolPanelParent" class="your-app-class ag-tool-panel-external"></div>The Popup Parent must also be set to an element that contains both the Tool Panel parent and the grid.
You can also provide a parent for the tool panel in the call to openToolPanel method:
Opens a particular tool panel. Provide the ID of the tool panel to open.
Optionally, provide a parent element to attach the tool panel to. |
import {
createApp,
defineComponent,
onMounted,
ref,
shallowRef,
useTemplateRef,
} from "vue";
import {
ClientSideRowModelModule,
type ColDef,
type GridApi,
type GridReadyEvent,
ModuleRegistry,
NumberFilterModule,
type SideBarDef,
TextFilterModule,
type ToolPanelDef,
enableDevValidations,
} from "ag-grid-community";
import {
ColumnsToolPanelModule,
NewFiltersToolPanelModule,
SetFilterModule,
} from "ag-grid-enterprise";
import { AgGridVue } from "ag-grid-vue3";
// Import data interface
import { IOlympicData } from "./interfaces";
import "./styles.css";
// Register AG Grid modules
if (process.env.NODE_ENV !== "production") {
// Enable extended validations only for development
enableDevValidations();
}
ModuleRegistry.registerModules([
NumberFilterModule,
ClientSideRowModelModule,
ColumnsToolPanelModule,
NewFiltersToolPanelModule,
SetFilterModule,
TextFilterModule,
]);
const VueExample = defineComponent({
template: `
<div style="height: 100%">
<div id="wrapper" class="example-wrapper">
<div class="example-header">
<button @click="openPopup">Open Columns Tool Panel</button>
<button @click="openDrawer">Open Filters Tool Panel</button>
</div>
<ag-grid-vue
style="width: 100%; height: 100%"
@grid-ready="onGridReady"
:popupParent="popupParent"
:columnDefs="columnDefs"
:defaultColDef="defaultColDef"
:autoGroupColumnDef="autoGroupColumnDef"
:sideBar="sideBar"
:rowData="rowData"
:enableFilterHandlers="true"
></ag-grid-vue>
</div>
<!-- Pop-up Panel -->
<div id="popup" ref="popup">
<div class="inner">
<button @click="closePopup">Close</button>
<div class="content" ref="popupContent"></div>
</div>
</div>
<!-- Drawer Panel -->
<div id="drawer" ref="drawer">
<div class="inner">
<button @click="closeDrawer">Close</button>
<div class="content" ref="drawerContent"></div>
</div>
</div>
</div>
`,
components: {
"ag-grid-vue": AgGridVue,
},
setup() {
const drawerRef = useTemplateRef<HTMLElement>("drawer");
const drawerContentRef = useTemplateRef<HTMLElement>("drawerContent");
const popupRef = useTemplateRef<HTMLElement>("popup");
const popupContentRef = useTemplateRef<HTMLElement>("popupContent");
const gridApi = shallowRef<GridApi<IOlympicData> | null>(null);
const columnDefs = ref<ColDef[]>([
{ field: "athlete", filter: "agTextColumnFilter", minWidth: 200 },
{ field: "country", minWidth: 180 },
{ field: "date", minWidth: 150 },
{ field: "gold", minWidth: 150 },
{ field: "silver", minWidth: 150 },
]);
const defaultColDef = ref<ColDef>({ flex: 1, minWidth: 100, filter: true });
const autoGroupColumnDef = ref<ColDef>({ minWidth: 200 });
const rowData = ref<IOlympicData[] | null>(null);
const columnsToolPanel = ref<ToolPanelDef>({
id: "columns",
labelDefault: "Popup",
labelKey: "columns",
iconKey: "columnsToolPanel",
toolPanel: "agColumnsToolPanel",
toolPanelParams: {
suppressRowGroups: true,
suppressValues: true,
suppressPivotMode: true,
},
parent: popupContentRef.value,
});
let popupParent = shallowRef(document.body);
const filtersToolPanel = ref<ToolPanelDef>({
id: "filters",
labelDefault: "Drawer",
labelKey: "filters",
iconKey: "filter",
toolPanel: "agNewFiltersToolPanel",
});
const sideBar = ref<SideBarDef | string | string[] | boolean | null>({
toolPanels: [columnsToolPanel.value, filtersToolPanel.value],
hideButtons: true,
hiddenByDefault: true,
});
function closePopup() {
const drawer = popupRef.value;
drawer!.classList.toggle("active", false);
gridApi.value!.closeToolPanel();
}
function closeDrawer() {
const drawer = drawerRef.value;
drawer!.classList.toggle("active", false);
gridApi.value!.closeToolPanel();
}
function openPopup() {
closeDrawer();
const popup = popupRef.value!;
popup.classList.toggle("active", true);
gridApi.value!.openToolPanel(
columnsToolPanel.value.id,
popupContentRef.value!,
);
}
function openDrawer() {
closePopup();
const drawer = drawerRef.value!;
drawer.classList.toggle("active", true);
gridApi.value!.openToolPanel(
filtersToolPanel.value.id,
drawer.querySelector<HTMLElement>(".content"),
);
}
const onGridReady = (params: GridReadyEvent) => {
gridApi.value = params.api;
const updateData = (data: any) => (rowData.value = data);
fetch("https://www.ag-grid.com/example-assets/olympic-winners.json")
.then((resp) => resp.json())
.then((data) => updateData(data));
};
onMounted(() => {
// Assign parents only after refs are resolved
columnsToolPanel.value.parent = popupContentRef.value;
filtersToolPanel.value.parent = drawerContentRef.value;
});
return {
gridApi,
popupParent,
columnDefs,
defaultColDef,
autoGroupColumnDef,
sideBar,
rowData,
onGridReady,
closePopup,
closeDrawer,
openPopup,
openDrawer,
};
},
});
const app = createApp(VueExample);
app.mount("#app");
.example-wrapper {
display: flex;
flex-direction: column;
height: 100%;
}
#myGrid {
flex: 1 1 0;
width: 100%;
}
.example-header {
margin-bottom: 10px;
}
#drawer.active,
#popup.active {
display: flex;
}
/* Base styles for the container */
#popup {
display: none; /* Hidden by default */
position: absolute;
top: 50%;
left: 50%;
transform: translate(-50%, -50%);
& .inner {
min-width: 300px;
}
& .content {
min-height: 200px;
}
}
#popup .inner {
border: 1px solid;
padding: 20px;
border-radius: 10px;
-webkit-font-smoothing: antialiased;
background-color: var(--example-background-color, white);
color: var(--example-text-color, black);
color-scheme: var(--example-color-scheme);
font-family: var(--example-font-family, Arial), sans-serif;
flex-direction: column;
}
/* Base styles for the container */
#drawer {
& .inner {
min-width: 300px;
}
& .content {
min-height: 200px;
}
position: fixed;
z-index: 2;
top: 54px;
bottom: 0;
width: 300px;
display: flex;
transform: translateX(-344px);
transition: transform 0.3s ease-in-out;
}
#drawer .content {
height: calc(100% - 90px);
}
#drawer .inner {
border: 1px solid;
padding: 20px;
border-radius: 10px;
-webkit-font-smoothing: antialiased;
background-color: var(--example-background-color, white);
color: var(--example-text-color, black);
color-scheme: var(--example-color-scheme);
font-family: var(--example-font-family, Arial), sans-serif;
flex-direction: column;
}
#drawer.active {
transform: translateX(0);
}
Providing Parameters to Tool Panels Copy Link
Parameters are passed to Tool Panels via the toolPanelParams object. For example, the following code snippet sets suppressRowGroups: true and suppressValues: true for the Columns Tool Panel.
<ag-grid-vue
:sideBar="sideBar"
/* other grid options ... */>
</ag-grid-vue>
this.sideBar = {
toolPanels: [
{
id: 'columns',
labelDefault: 'Columns',
labelKey: 'columns',
iconKey: 'columns',
toolPanel: 'agColumnsToolPanel',
toolPanelParams: {
suppressRowGroups: true,
suppressValues: true,
}
}
]
};See the Columns Tool Panel documentation for the full list of possible parameters to this Tool Panel.
Animation Copy Link
By default, sidebar panels open and close instantly. You can enable a smooth slide animation using the Theming API parameter sideBarPanelAnimationDuration. Set it to a value in seconds:
const myTheme = themeQuartz.withParams({
sideBarPanelAnimationDuration: 0.3,
});The animation is automatically disabled for users who have requested reduced motion in their OS accessibility settings.
import {
createApp,
defineComponent,
onBeforeMount,
ref,
shallowRef,
} from "vue";
import { AgGridVue } from "ag-grid-vue3";
import {
ClientSideRowModelModule,
ColDef,
ColGroupDef,
GridApi,
GridOptions,
GridReadyEvent,
ModuleRegistry,
NumberFilterModule,
SideBarDef,
TextFilterModule,
Theme,
enableDevValidations,
themeQuartz,
} from "ag-grid-community";
import {
ColumnsToolPanelModule,
NewFiltersToolPanelModule,
PivotModule,
SideBarModule,
} from "ag-grid-enterprise";
import { IOlympicData } from "./interfaces";
if (process.env.NODE_ENV !== "production") {
// Enable extended validations only for development
enableDevValidations();
}
ModuleRegistry.registerModules([
ClientSideRowModelModule,
ColumnsToolPanelModule,
NewFiltersToolPanelModule,
TextFilterModule,
NumberFilterModule,
SideBarModule,
PivotModule,
]);
const myTheme = themeQuartz.withParams({
sideBarPanelAnimationDuration: 0.3,
});
const VueExample = defineComponent({
template: `
<div style="height: 100%">
<ag-grid-vue
style="width: 100%; height: 100%;"
@grid-ready="onGridReady"
:columnDefs="columnDefs"
:theme="theme"
:defaultColDef="defaultColDef"
:enableFilterHandlers="true"
:sideBar="sideBar"
:rowData="rowData"></ag-grid-vue>
</div>
`,
components: {
"ag-grid-vue": AgGridVue,
},
setup(props) {
const gridApi = shallowRef<GridApi<IOlympicData> | null>(null);
const columnDefs = ref<ColDef[]>([
{ field: "athlete" },
{ field: "country" },
{ field: "sport" },
{ field: "year" },
]);
const theme = ref<Theme | "legacy">(myTheme);
const defaultColDef = ref<ColDef>({
flex: 1,
filter: true,
sortable: true,
resizable: true,
});
const sideBar = ref<SideBarDef | string | string[] | boolean | null>([
"columns",
"filters-new",
]);
const rowData = ref<IOlympicData[]>(null);
const onGridReady = (params: GridReadyEvent) => {
gridApi.value = params.api;
const updateData = (data) => (rowData.value = data);
fetch("https://www.ag-grid.com/example-assets/olympic-winners.json")
.then((resp) => resp.json())
.then((data) => updateData(data));
};
return {
gridApi,
columnDefs,
theme,
defaultColDef,
sideBar,
rowData,
onGridReady,
};
},
});
const app = createApp(VueExample);
app.mount("#app");
Side Bar API Copy Link
The Side Bar state can be saved and restored as part of Grid State.
The list below details all the API methods relevant to the Tool Panel.
Returns the current side bar configuration. If a shortcut was used, returns the detailed long form. |
Show/hide the entire side bar, including any visible panel and the tab buttons. |
Returns true if the side bar is visible. |
Sets the side bar position relative to the grid. Possible values are 'left' or 'right'. |
Opens a particular tool panel. Provide the ID of the tool panel to open.
Optionally, provide a parent element to attach the tool panel to. |
Closes the currently open tool panel (if any). |
Returns the ID of the currently shown tool panel if any, otherwise null. |
Returns true if the tool panel is showing, otherwise false. |
Force refreshes all tool panels by calling their refresh method. |
Gets the tool panel instance corresponding to the supplied id. |
The example below demonstrates different usages of the Tool Panel API methods. The following can be noted:
- Initially the Side Bar is not visible as
sideBar.hiddenByDefault=true. - Visibility Buttons: These toggle visibility of the Tool Panel. Note that when you make
visible=false, the entire Tool Panel is hidden including the tabs. Make sure the Tool Panel is left visible before testing the other API features so you can see the impact. - Open / Close Buttons: These open and close different Tool Panel items.
- Reset Buttons: These reset the Tool Panel to a new configuration. Notice that shortcuts are provided as configuration however
getSideBar()returns back the long form. - Position Buttons: These change the position of the Side Bar relative to the grid.
- The
get*buttons log data to the developer console.
import {
createApp,
defineComponent,
onBeforeMount,
ref,
shallowRef,
} from "vue";
import { AgGridVue } from "ag-grid-vue3";
import "./style.css";
import {
AutoGroupColumnDef,
ClientSideRowModelModule,
ColDef,
ColGroupDef,
GridApi,
GridOptions,
GridReadyEvent,
ModuleRegistry,
NumberFilterModule,
SideBarDef,
TextFilterModule,
ToolPanelSizeChangedEvent,
ToolPanelVisibleChangedEvent,
enableDevValidations,
} from "ag-grid-community";
import {
ColumnsToolPanelModule,
FiltersToolPanelModule,
PivotModule,
SetFilterModule,
} from "ag-grid-enterprise";
import { IOlympicData } from "./interfaces";
if (process.env.NODE_ENV !== "production") {
// Enable extended validations only for development
enableDevValidations();
}
ModuleRegistry.registerModules([
NumberFilterModule,
ClientSideRowModelModule,
ColumnsToolPanelModule,
FiltersToolPanelModule,
SetFilterModule,
PivotModule,
TextFilterModule,
]);
const VueExample = defineComponent({
template: `
<div style="height: 100%">
<div class="parent-div">
<div class="api-panel">
<div class="api-column">
Visibility
<button v-on:click="setSideBarVisible(true)">setSideBarVisible(true)</button>
<button v-on:click="setSideBarVisible(false)">setSideBarVisible(false)</button>
<button v-on:click="isSideBarVisible()">isSideBarVisible()</button>
</div>
<div class="api-column">
Open & Close
<button v-on:click="openToolPanel('columns')">openToolPanel('columns')</button>
<button v-on:click="openToolPanel('filters')">openToolPanel('filters')</button>
<button v-on:click="closeToolPanel()">closeToolPanel()</button>
<button v-on:click="getOpenedToolPanel()">getOpenedToolPanel()</button>
</div>
<div class="api-column">
Reset
<button v-on:click="setSideBar(['filters', 'columns'])">setSideBar(['filters','columns'])</button>
<button v-on:click="setSideBar('columns')">setSideBar('columns')</button>
<button v-on:click="getSideBar()">getSideBar()</button>
</div>
<div class="api-column">
Position
<button v-on:click="setSideBarPosition('left')">setSideBarPosition('left')</button>
<button v-on:click="setSideBarPosition('right')">setSideBarPosition('right')</button>
</div>
</div>
<ag-grid-vue
style="width: 100%; height: 100%;"
class="grid-div"
@grid-ready="onGridReady"
:columnDefs="columnDefs"
:defaultColDef="defaultColDef"
:autoGroupColumnDef="autoGroupColumnDef"
:sideBar="sideBar"
:rowData="rowData"
@tool-panel-visible-changed="onToolPanelVisibleChanged"
@tool-panel-size-changed="onToolPanelSizeChanged"></ag-grid-vue>
</div>
</div>
`,
components: {
"ag-grid-vue": AgGridVue,
},
setup(props) {
const gridApi = shallowRef<GridApi<IOlympicData> | null>(null);
const columnDefs = ref<ColDef[]>([
{ field: "athlete", filter: "agTextColumnFilter", minWidth: 200 },
{ field: "age" },
{ field: "country", minWidth: 200 },
{ field: "year" },
{ field: "date", minWidth: 160 },
{ field: "gold" },
{ field: "silver" },
{ field: "bronze" },
{ field: "total" },
]);
const defaultColDef = ref<ColDef>({
flex: 1,
minWidth: 100,
// allow every column to be aggregated
enableValue: true,
// allow every column to be grouped
enableRowGroup: true,
// allow every column to be pivoted
enablePivot: true,
filter: true,
});
const autoGroupColumnDef = ref<AutoGroupColumnDef>({
minWidth: 200,
});
const sideBar = ref<SideBarDef | string | string[] | boolean | null>({
toolPanels: [
{
id: "columns",
labelDefault: "Columns",
labelKey: "columns",
iconKey: "columns",
toolPanel: "agColumnsToolPanel",
},
{
id: "filters",
labelDefault: "Filters",
labelKey: "filters",
iconKey: "filter",
toolPanel: "agFiltersToolPanel",
},
],
defaultToolPanel: "filters",
hiddenByDefault: true,
});
const rowData = ref<IOlympicData[]>(null);
function onToolPanelVisibleChanged(event: ToolPanelVisibleChangedEvent) {
console.log("toolPanelVisibleChanged", event);
}
function onToolPanelSizeChanged(event: ToolPanelSizeChangedEvent) {
console.log("toolPanelSizeChanged", event);
}
function setSideBarVisible(value: boolean) {
gridApi.value!.setSideBarVisible(value);
}
function isSideBarVisible() {
console.log(gridApi.value!.isSideBarVisible());
}
function openToolPanel(key: string) {
gridApi.value!.openToolPanel(key);
}
function closeToolPanel() {
gridApi.value!.closeToolPanel();
}
function getOpenedToolPanel() {
console.log(gridApi.value!.getOpenedToolPanel());
}
function setSideBar(def: SideBarDef | string | string[] | boolean) {
gridApi.value!.setGridOption("sideBar", def);
}
function getSideBar() {
const sideBar = gridApi.value!.getSideBar();
console.log(JSON.stringify(sideBar));
console.log(sideBar);
}
function setSideBarPosition(position: "left" | "right") {
gridApi.value!.setSideBarPosition(position);
}
const onGridReady = (params: GridReadyEvent) => {
gridApi.value = params.api;
const updateData = (data) => (rowData.value = data);
fetch("https://www.ag-grid.com/example-assets/olympic-winners.json")
.then((resp) => resp.json())
.then((data) => updateData(data));
};
return {
gridApi,
columnDefs,
defaultColDef,
autoGroupColumnDef,
sideBar,
rowData,
onGridReady,
onToolPanelVisibleChanged,
onToolPanelSizeChanged,
setSideBarVisible,
isSideBarVisible,
openToolPanel,
closeToolPanel,
getOpenedToolPanel,
setSideBar,
getSideBar,
setSideBarPosition,
};
},
});
const app = createApp(VueExample);
app.mount("#app");
.api-panel {
display: flex;
flex-direction: row;
flex-wrap: wrap;
font-family: Verdana, Geneva, Tahoma, sans-serif;
font-size: 13px;
}
.api-column {
padding: 0px 5px 5px;
text-align: center;
width: 215px;
max-height: 200px;
}
.api-column button {
width: 100%;
}
.api-column button:first-child {
margin-top: 5px;
}
.api-panel button {
margin: 2px;
}
.grid-div {
height: 100%;
}
.parent-div {
height: 100%;
display: grid;
grid-template-rows: auto 1fr;
}

This section covers how to configure the Side Bar which contains Tool Panels.
Configuring the Side Bar Copy Link
The Side Bar is configured using the grid property sideBar. The property takes multiple forms to allow easy configuration or more advanced configuration. The different forms for the sideBar property are as follows:
| Type | Description |
|---|---|
undefined / null | No Side Bar provided. |
boolean | Set to true to display the Side Bar with default configuration. |
string / string[] | Set to 'columns', 'filters' or 'filters-new' to display the Side Bar with just one of Columns, Filters or New Filters Tool Panels or an array of some or all of these values. |
SideBarDef(long form) | An object of type SideBarDef (explained below) to allow detailed configuration of the Side Bar. Use this to configure the provided Tool Panels (e.g. pass parameters to the columns or filters panel) or to include custom Tool Panels. |
Boolean Configuration Copy Link
The default Side Bar contains the Columns and Filters Tool Panels. To use the default Side Bar, set the grid property sideBar=true. The Columns panel will be open by default.
The default configuration doesn't allow customisation of the Tool Panels.
"use client";
import React, {
useCallback,
useMemo,
useRef,
useState,
StrictMode,
} from "react";
import { createRoot } from "react-dom/client";
import { AgGridReact, AgGridProvider } from "ag-grid-react";
import {
AutoGroupColumnDef,
ClientSideRowModelModule,
ColDef,
ColGroupDef,
GridApi,
GridOptions,
ModuleRegistry,
NumberFilterModule,
SideBarDef,
TextFilterModule,
enableDevValidations,
} from "ag-grid-community";
import {
ColumnsToolPanelModule,
FiltersToolPanelModule,
PivotModule,
SetFilterModule,
} from "ag-grid-enterprise";
import { IOlympicData } from "./interfaces";
import { useFetchJson } from "./useFetchJson";
if (process.env.NODE_ENV !== "production") {
// Enable extended validations only for development
enableDevValidations();
}
const modules = [
NumberFilterModule,
ClientSideRowModelModule,
ColumnsToolPanelModule,
FiltersToolPanelModule,
SetFilterModule,
PivotModule,
TextFilterModule,
];
const GridExample = () => {
const containerStyle = useMemo(() => ({ width: "100%", height: "100%" }), []);
const gridStyle = useMemo(() => ({ height: "100%", width: "100%" }), []);
const [columnDefs, setColumnDefs] = useState<ColDef[]>([
{ field: "athlete", filter: "agTextColumnFilter", minWidth: 200 },
{ field: "age" },
{ field: "country", minWidth: 180 },
{ field: "year" },
{ field: "date", minWidth: 150 },
{ field: "gold" },
{ field: "silver" },
{ field: "bronze" },
{ field: "total" },
]);
const defaultColDef = useMemo<ColDef>(() => {
return {
flex: 1,
minWidth: 100,
// allow every column to be aggregated
enableValue: true,
// allow every column to be grouped
enableRowGroup: true,
// allow every column to be pivoted
enablePivot: true,
filter: true,
};
}, []);
const autoGroupColumnDef = useMemo<AutoGroupColumnDef>(() => {
return {
minWidth: 200,
};
}, []);
const { data, loading } = useFetchJson<IOlympicData>(
"https://www.ag-grid.com/example-assets/olympic-winners.json",
);
return (
<AgGridProvider modules={modules}>
<div style={containerStyle}>
<div style={gridStyle}>
<AgGridReact<IOlympicData>
rowData={data}
loading={loading}
columnDefs={columnDefs}
defaultColDef={defaultColDef}
autoGroupColumnDef={autoGroupColumnDef}
sideBar={true}
/>
</div>
</div>
</AgGridProvider>
);
};
const root = createRoot(document.getElementById("root")!);
root.render(
<StrictMode>
<GridExample />
</StrictMode>,
);
export interface IOlympicData {
athlete: string,
age: number,
country: string,
year: number,
date: string,
sport: string,
gold: number,
silver: number,
bronze: number,
total: number
} import { useState, useEffect } from 'react';
/**
* Fetch example Json data
* Not recommended for production use!
*/
export const useFetchJson = <T,>(url:string, limit?: number) => {
const [data, setData] = useState<T[]>();
const [loading, setLoading] = useState(true);
useEffect(() => {
// StrictMode runs this effect twice: drop the superseded run's response rather than applying both.
let cancelled = false;
const fetchData = async () => {
setLoading(true);
// Note error handling is omitted here for brevity
const response = await fetch(url);
const json = await response.json();
const data = limit ? json.slice(0, limit) : json;
if (cancelled) {
return;
}
setData(data);
setLoading(false);
};
fetchData();
return () => {
cancelled = true;
};
}, [url, limit]);
return { data, loading };
}; String Configuration Copy Link
To display just one of the provided Tool Panels, set either sideBar='columns', sideBar='filters' or sideBar='filters-new'. This will display the desired item with default configuration. Alternatively pass some or all of these values as a string[], i.e sideBar=['columns','filters', 'filters-new'].
The example below demonstrates using the string configuration. Note the following:
- The grid property
sideBaris set to'filters'. - The Side Bar is displayed showing only the Filters panel.
"use client";
import React, {
useCallback,
useMemo,
useRef,
useState,
StrictMode,
} from "react";
import { createRoot } from "react-dom/client";
import { AgGridReact, AgGridProvider } from "ag-grid-react";
import {
ClientSideRowModelModule,
ColDef,
ColGroupDef,
GridApi,
GridOptions,
ModuleRegistry,
NumberFilterModule,
SideBarDef,
TextFilterModule,
enableDevValidations,
} from "ag-grid-community";
import {
ColumnsToolPanelModule,
FiltersToolPanelModule,
PivotModule,
SetFilterModule,
} from "ag-grid-enterprise";
import { IOlympicData } from "./interfaces";
import { useFetchJson } from "./useFetchJson";
if (process.env.NODE_ENV !== "production") {
// Enable extended validations only for development
enableDevValidations();
}
const modules = [
NumberFilterModule,
ClientSideRowModelModule,
ColumnsToolPanelModule,
FiltersToolPanelModule,
SetFilterModule,
PivotModule,
TextFilterModule,
];
const GridExample = () => {
const containerStyle = useMemo(() => ({ width: "100%", height: "100%" }), []);
const gridStyle = useMemo(() => ({ height: "100%", width: "100%" }), []);
const [columnDefs, setColumnDefs] = useState<ColDef[]>([
{ field: "athlete", filter: "agTextColumnFilter", minWidth: 200 },
{ field: "age" },
{ field: "country", minWidth: 180 },
{ field: "year" },
{ field: "date", minWidth: 150 },
{ field: "gold" },
{ field: "silver" },
{ field: "bronze" },
{ field: "total" },
]);
const defaultColDef = useMemo<ColDef>(() => {
return {
flex: 1,
minWidth: 100,
// allow every column to be aggregated
enableValue: true,
// allow every column to be grouped
enableRowGroup: true,
// allow every column to be pivoted
enablePivot: true,
filter: true,
};
}, []);
const { data, loading } = useFetchJson<IOlympicData>(
"https://www.ag-grid.com/example-assets/olympic-winners.json",
);
return (
<AgGridProvider modules={modules}>
<div style={containerStyle}>
<div style={gridStyle}>
<AgGridReact<IOlympicData>
rowData={data}
loading={loading}
columnDefs={columnDefs}
defaultColDef={defaultColDef}
sideBar={"filters"}
/>
</div>
</div>
</AgGridProvider>
);
};
const root = createRoot(document.getElementById("root")!);
root.render(
<StrictMode>
<GridExample />
</StrictMode>,
);
export interface IOlympicData {
athlete: string,
age: number,
country: string,
year: number,
date: string,
sport: string,
gold: number,
silver: number,
bronze: number,
total: number
} import { useState, useEffect } from 'react';
/**
* Fetch example Json data
* Not recommended for production use!
*/
export const useFetchJson = <T,>(url:string, limit?: number) => {
const [data, setData] = useState<T[]>();
const [loading, setLoading] = useState(true);
useEffect(() => {
// StrictMode runs this effect twice: drop the superseded run's response rather than applying both.
let cancelled = false;
const fetchData = async () => {
setLoading(true);
// Note error handling is omitted here for brevity
const response = await fetch(url);
const json = await response.json();
const data = limit ? json.slice(0, limit) : json;
if (cancelled) {
return;
}
setData(data);
setLoading(false);
};
fetchData();
return () => {
cancelled = true;
};
}, [url, limit]);
return { data, loading };
}; SideBarDef Configuration Copy Link
The previous configurations are shortcuts for the full fledged configuration using a SideBarDef object. For full control over the configuration, you must provide a SideBarDef object.
Properties available on the SideBarDef interface.
A list of all the panels to place in the side bar. The panels will be displayed in the provided order from top to bottom.
|
The panel (identified by ID) to open by default. If none specified, the side bar is initially displayed closed. |
To hide the side bar by default, set this to true. If left undefined the side bar will be shown. |
Sets the side bar position relative to the grid. |
To hide the side bar buttons by default set this to true. If left undefined the buttons will be shown. This is useful if you want to show a tool panel without showing the buttons. |
The toolPanels property follows the ToolPanelDef interface:
Properties available on the ToolPanelDef interface.
The unique ID for this panel. Used in the API and elsewhere to refer to the panel. |
The key used for localisation for displaying the label. The label is displayed in the tab button. |
The default label if labelKey is missing or does not map to valid text through localisation. |
The min width of the tool panel. |
The max width of the tool panel. |
The initial width of the tool panel. |
The key of the icon to be used as a graphical aid beside the label in the side bar. |
The tool panel component to use as the panel. The provided panels use components agColumnsToolPanel, agFiltersToolPanel and agNewFiltersToolPanel. To provide your own custom panel component, you reference it here.
|
Customise the parameters provided to the toolPanel component. |
DOM element to use as the parent for the tool panel to allow it to appear outside the grid. Set to null or omit the property for tool panel to appear inside the grid.
|
The following snippet shows configuring the Tool Panel using a SideBarDef object:
const sideBar = useMemo(() => {
return {
toolPanels: [
{
id: 'columns',
labelDefault: 'Columns',
labelKey: 'columns',
iconKey: 'columns',
toolPanel: 'agColumnsToolPanel',
minWidth: 225,
maxWidth: 225,
width: 225
},
{
id: 'filters',
labelDefault: 'Filters',
labelKey: 'filters',
iconKey: 'filter',
toolPanel: 'agFiltersToolPanel',
minWidth: 180,
maxWidth: 400,
width: 250
}
],
position: 'left',
defaultToolPanel: 'filters',
};
}, []);
<AgGridReact sideBar={sideBar} />The snippet above is demonstrated in the following example:
"use client";
import React, {
useCallback,
useMemo,
useRef,
useState,
StrictMode,
} from "react";
import { createRoot } from "react-dom/client";
import { AgGridReact, AgGridProvider } from "ag-grid-react";
import {
AutoGroupColumnDef,
ClientSideRowModelModule,
ColDef,
ColGroupDef,
GridApi,
GridOptions,
ModuleRegistry,
NumberFilterModule,
SideBarDef,
TextFilterModule,
enableDevValidations,
} from "ag-grid-community";
import {
ColumnsToolPanelModule,
FiltersToolPanelModule,
PivotModule,
SetFilterModule,
} from "ag-grid-enterprise";
import { IOlympicData } from "./interfaces";
import { useFetchJson } from "./useFetchJson";
if (process.env.NODE_ENV !== "production") {
// Enable extended validations only for development
enableDevValidations();
}
const modules = [
NumberFilterModule,
ClientSideRowModelModule,
ColumnsToolPanelModule,
FiltersToolPanelModule,
SetFilterModule,
PivotModule,
TextFilterModule,
];
const GridExample = () => {
const containerStyle = useMemo(() => ({ width: "100%", height: "100%" }), []);
const gridStyle = useMemo(() => ({ height: "100%", width: "100%" }), []);
const [columnDefs, setColumnDefs] = useState<ColDef[]>([
{ field: "athlete", filter: "agTextColumnFilter", minWidth: 200 },
{ field: "age" },
{ field: "country", minWidth: 180 },
{ field: "year" },
{ field: "date", minWidth: 150 },
{ field: "gold" },
{ field: "silver" },
{ field: "bronze" },
{ field: "total" },
]);
const defaultColDef = useMemo<ColDef>(() => {
return {
flex: 1,
minWidth: 100,
// allow every column to be aggregated
enableValue: true,
// allow every column to be grouped
enableRowGroup: true,
// allow every column to be pivoted
enablePivot: true,
filter: true,
};
}, []);
const autoGroupColumnDef = useMemo<AutoGroupColumnDef>(() => {
return {
minWidth: 200,
};
}, []);
const sideBar = useMemo<
SideBarDef | string | string[] | boolean | null
>(() => {
return {
toolPanels: [
{
id: "columns",
labelDefault: "Columns",
labelKey: "columns",
iconKey: "columns",
toolPanel: "agColumnsToolPanel",
minWidth: 225,
width: 225,
maxWidth: 225,
},
{
id: "filters",
labelDefault: "Filters",
labelKey: "filters",
iconKey: "filter",
toolPanel: "agFiltersToolPanel",
minWidth: 180,
maxWidth: 400,
width: 250,
},
],
position: "left",
defaultToolPanel: "filters",
};
}, []);
const { data, loading } = useFetchJson<IOlympicData>(
"https://www.ag-grid.com/example-assets/olympic-winners.json",
);
return (
<AgGridProvider modules={modules}>
<div style={containerStyle}>
<div style={gridStyle}>
<AgGridReact<IOlympicData>
rowData={data}
loading={loading}
columnDefs={columnDefs}
defaultColDef={defaultColDef}
autoGroupColumnDef={autoGroupColumnDef}
sideBar={sideBar}
/>
</div>
</div>
</AgGridProvider>
);
};
const root = createRoot(document.getElementById("root")!);
root.render(
<StrictMode>
<GridExample />
</StrictMode>,
);
export interface IOlympicData {
athlete: string,
age: number,
country: string,
year: number,
date: string,
sport: string,
gold: number,
silver: number,
bronze: number,
total: number
} import { useState, useEffect } from 'react';
/**
* Fetch example Json data
* Not recommended for production use!
*/
export const useFetchJson = <T,>(url:string, limit?: number) => {
const [data, setData] = useState<T[]>();
const [loading, setLoading] = useState(true);
useEffect(() => {
// StrictMode runs this effect twice: drop the superseded run's response rather than applying both.
let cancelled = false;
const fetchData = async () => {
setLoading(true);
// Note error handling is omitted here for brevity
const response = await fetch(url);
const json = await response.json();
const data = limit ? json.slice(0, limit) : json;
if (cancelled) {
return;
}
setData(data);
setLoading(false);
};
fetchData();
return () => {
cancelled = true;
};
}, [url, limit]);
return { data, loading };
}; Calling setSideBarVisible(true) when sideBarDef.hideButtons is set to true and no tool panel is open will not display anything.
The Popup Parent must be set to an element that contains both the tool panel parent and the grid to ensure all popups (e.g., Columns Tool Panel context menus) are fully visible.
Configuration Shortcuts Copy Link
The boolean and string configurations are shortcuts for more detailed configurations. When you use a shortcut the grid replaces it with the equivalent long form of the configuration by building the equivalent SideBarDef.
The following code snippets show an example of the boolean shortcut and the equivalent SideBarDef long form.
// shortcut
const sideBar = true;
<AgGridReact sideBar={sideBar} />// equivalent detailed long form
const sideBar = useMemo(() => {
return {
toolPanels: [
{
id: 'columns',
labelDefault: 'Columns',
labelKey: 'columns',
iconKey: 'columns',
toolPanel: 'agColumnsToolPanel',
},
{
id: 'filters',
labelDefault: 'Filters',
labelKey: 'filters',
iconKey: 'filter',
toolPanel: 'agFiltersToolPanel',
}
],
defaultToolPanel: 'columns',
};
}, []);
<AgGridReact sideBar={sideBar} />The following code snippets show an example of the string shortcut and the equivalent SideBarDef long form.
// shortcut
const sideBar = 'filters';
<AgGridReact sideBar={sideBar} />// equivalent detailed long form
const sideBar = useMemo(() => {
return {
toolPanels: [
{
id: 'filters',
labelDefault: 'Filters',
labelKey: 'filters',
iconKey: 'filter',
toolPanel: 'agFiltersToolPanel',
}
],
defaultToolPanel: 'filters',
};
}, []);
<AgGridReact sideBar={sideBar} />You can also use shortcuts inside the sideBar.toolPanels array for specifying the Columns and Filters items.
// shortcut
const sideBar = useMemo(() => {
return {
toolPanels: ['columns', 'filters']
};
}, []);
<AgGridReact sideBar={sideBar} />// equivalent detailed long form
const sideBar = useMemo(() => {
return {
toolPanels: [
{
id: 'columns',
labelDefault: 'Columns',
labelKey: 'columns',
iconKey: 'columns',
toolPanel: 'agColumnsToolPanel',
},
{
id: 'filters',
labelDefault: 'Filters',
labelKey: 'filters',
iconKey: 'filter',
toolPanel: 'agFiltersToolPanel',
}
]
};
}, []);
<AgGridReact sideBar={sideBar} /> Side Bar Customisation Copy Link
If you are using the long form (providing a SideBarDef object) then it is possible to customise. The example below changes the filter label and icon.
"use client";
import React, {
useCallback,
useMemo,
useRef,
useState,
StrictMode,
} from "react";
import { createRoot } from "react-dom/client";
import { AgGridReact, AgGridProvider } from "ag-grid-react";
import {
AutoGroupColumnDef,
ClientSideRowModelModule,
ColDef,
ColGroupDef,
GridApi,
GridOptions,
ModuleRegistry,
NumberFilterModule,
SideBarDef,
TextFilterModule,
enableDevValidations,
} from "ag-grid-community";
import {
ColumnsToolPanelModule,
FiltersToolPanelModule,
PivotModule,
SetFilterModule,
} from "ag-grid-enterprise";
import { IOlympicData } from "./interfaces";
import { useFetchJson } from "./useFetchJson";
if (process.env.NODE_ENV !== "production") {
// Enable extended validations only for development
enableDevValidations();
}
const modules = [
NumberFilterModule,
ClientSideRowModelModule,
ColumnsToolPanelModule,
FiltersToolPanelModule,
SetFilterModule,
PivotModule,
TextFilterModule,
];
const GridExample = () => {
const containerStyle = useMemo(() => ({ width: "100%", height: "100%" }), []);
const gridStyle = useMemo(() => ({ height: "100%", width: "100%" }), []);
const [columnDefs, setColumnDefs] = useState<ColDef[]>([
{ field: "athlete", filter: "agTextColumnFilter", minWidth: 200 },
{ field: "age" },
{ field: "country", minWidth: 180 },
{ field: "year" },
{ field: "date", minWidth: 150 },
{ field: "gold" },
{ field: "silver" },
{ field: "bronze" },
{ field: "total" },
]);
const defaultColDef = useMemo<ColDef>(() => {
return {
flex: 1,
minWidth: 100,
// allow every column to be aggregated
enableValue: true,
// allow every column to be grouped
enableRowGroup: true,
// allow every column to be pivoted
enablePivot: true,
filter: true,
};
}, []);
const autoGroupColumnDef = useMemo<AutoGroupColumnDef>(() => {
return {
minWidth: 200,
};
}, []);
const sideBar = useMemo<
SideBarDef | string | string[] | boolean | null
>(() => {
return {
toolPanels: [
"columns",
{
id: "filters",
labelKey: "filters",
labelDefault: "Filters",
iconKey: "menu",
toolPanel: "agFiltersToolPanel",
},
{
id: "filters 2",
labelKey: "filters",
labelDefault: "Filters XXXXXXXX",
iconKey: "filter",
toolPanel: "agFiltersToolPanel",
},
],
defaultToolPanel: "filters",
};
}, []);
const { data, loading } = useFetchJson<IOlympicData>(
"https://www.ag-grid.com/example-assets/olympic-winners.json",
);
return (
<AgGridProvider modules={modules}>
<div style={containerStyle}>
<div style={gridStyle}>
<AgGridReact<IOlympicData>
rowData={data}
loading={loading}
columnDefs={columnDefs}
defaultColDef={defaultColDef}
autoGroupColumnDef={autoGroupColumnDef}
sideBar={sideBar}
/>
</div>
</div>
</AgGridProvider>
);
};
const root = createRoot(document.getElementById("root")!);
root.render(
<StrictMode>
<GridExample />
</StrictMode>,
);
export interface IOlympicData {
athlete: string,
age: number,
country: string,
year: number,
date: string,
sport: string,
gold: number,
silver: number,
bronze: number,
total: number
} import { useState, useEffect } from 'react';
/**
* Fetch example Json data
* Not recommended for production use!
*/
export const useFetchJson = <T,>(url:string, limit?: number) => {
const [data, setData] = useState<T[]>();
const [loading, setLoading] = useState(true);
useEffect(() => {
// StrictMode runs this effect twice: drop the superseded run's response rather than applying both.
let cancelled = false;
const fetchData = async () => {
setLoading(true);
// Note error handling is omitted here for brevity
const response = await fetch(url);
const json = await response.json();
const data = limit ? json.slice(0, limit) : json;
if (cancelled) {
return;
}
setData(data);
setLoading(false);
};
fetchData();
return () => {
cancelled = true;
};
}, [url, limit]);
return { data, loading };
}; Tool Panel Parent Copy Link
By default, Tool Panels are rendered inside the Side Bar. If you want to render Tool Panels in a different location, you can set the parent property in the ToolPanelDef. This is useful if you want to render Tool Panel in a different part of your application, such as a popup window or a separate section of your page.
To ensure correct panel sizing, AG Grid adds a CSS class to the parent element. If your component also sets the parent class it may overwrite this, so include the ag-tool-panel-external class when setting the parent class:
<div ref={toolPanelParent}
className="your-app-class ag-tool-panel-external"></div>The Popup Parent must also be set to an element that contains both the Tool Panel parent and the grid.
You can also provide a parent for the tool panel in the call to openToolPanel method:
Opens a particular tool panel. Provide the ID of the tool panel to open.
Optionally, provide a parent element to attach the tool panel to. |
"use client";
import React, {
StrictMode,
useCallback,
useMemo,
useRef,
useState,
} from "react";
import { createRoot } from "react-dom/client";
import {
ClientSideRowModelModule,
ColumnsToolPanelModule,
NewFiltersToolPanelModule,
NumberFilterModule,
PivotModule,
SetFilterModule,
TextFilterModule,
enableDevValidations,
} from "ag-grid-enterprise";
import { AgGridProvider, AgGridReact } from "ag-grid-react";
import "./styles.css";
import { useFetchJson } from "./useFetchJson";
if (process.env.NODE_ENV !== "production") {
// Enable extended validations only for development
enableDevValidations();
}
const modules = [
NumberFilterModule,
ClientSideRowModelModule,
ColumnsToolPanelModule,
NewFiltersToolPanelModule,
SetFilterModule,
PivotModule,
TextFilterModule,
];
const GridExample = () => {
const gridRef = useRef(null);
const containerStyle = useMemo(() => ({ width: "100%", height: "100%" }), []);
const gridStyle = useMemo(() => ({ height: "100%", width: "100%" }), []);
const popupRef = useRef<HTMLElement>(null);
const popupContentRef = useRef<HTMLElement>(null);
const drawerRef = useRef<HTMLElement>(null);
const drawerContentRef = useRef<HTMLElement>(null);
const [popupParent, setPopupParent] = useState<HTMLElement | null>(
document.body,
);
const [columnDefs, setColumnDefs] = useState([
{ field: "athlete", filter: "agTextColumnFilter", minWidth: 200 },
{ field: "country", minWidth: 180 },
{ field: "date", minWidth: 150 },
{ field: "gold", minWidth: 150 },
{ field: "silver", minWidth: 150 },
]);
const defaultColDef = useMemo(
() => ({ flex: 1, minWidth: 100, filter: true }),
[],
);
const autoGroupColumnDef = useMemo(() => ({ minWidth: 200 }), []);
const { data, loading } = useFetchJson(
"https://www.ag-grid.com/example-assets/olympic-winners.json",
);
const columnsToolPanel = useMemo(() => {
return {
id: "columns",
labelDefault: "Popup",
labelKey: "columns",
iconKey: "columnsToolPanel",
toolPanel: "agColumnsToolPanel",
toolPanelParams: {
suppressRowGroups: true,
suppressValues: true,
suppressPivotMode: true,
},
parent: popupContentRef.current,
};
}, [popupRef.current, popupContentRef.current]);
const filtersToolPanel = useMemo(
() => ({
id: "filters",
labelDefault: "Drawer",
labelKey: "filters",
iconKey: "filter",
toolPanel: "agNewFiltersToolPanel",
}),
[],
);
const sideBar = useMemo(
() => ({
toolPanels: [columnsToolPanel, filtersToolPanel],
hideButtons: true,
hiddenByDefault: true,
}),
[columnsToolPanel, filtersToolPanel],
);
const closePopup = useCallback(() => {
const drawer = popupRef.current;
drawer.classList.toggle("active", false);
gridRef.current.api.closeToolPanel();
}, [popupRef.current]);
const closeDrawer = useCallback(() => {
const drawer = drawerRef.current;
drawer.classList.toggle("active", false);
gridRef.current.api.closeToolPanel();
}, [drawerRef.current]);
const openPopup = useCallback(() => {
closeDrawer();
const popup = popupRef.current;
popup.classList.toggle("active", true);
gridRef.current.api.openToolPanel(columnsToolPanel.id);
}, [popupRef.current, closeDrawer, columnsToolPanel]);
const openDrawer = useCallback(() => {
closePopup();
const drawer = drawerRef.current;
drawer.classList.toggle("active", true);
gridRef.current.api.openToolPanel(
filtersToolPanel.id,
drawerContentRef.current,
);
}, [drawerRef, closePopup, filtersToolPanel]);
return (
<AgGridProvider modules={modules}>
<div style={containerStyle}>
<div id="wrapper" className="example-wrapper">
<div className="example-header">
<button onClick={openPopup}>Open Columns Tool Panel</button>
<button onClick={openDrawer}>Open Filters Tool Panel</button>
</div>
<div style={gridStyle}>
<AgGridReact
enableFilterHandlers
ref={gridRef}
rowData={data}
loading={loading}
popupParent={popupParent}
columnDefs={columnDefs}
defaultColDef={defaultColDef}
autoGroupColumnDef={autoGroupColumnDef}
sideBar={sideBar}
/>
</div>
</div>
<div id="popup" ref={popupRef}>
<div className="inner">
<div>
<button onClick={closePopup}>Close</button>
</div>
<div className="content" ref={popupContentRef}></div>
</div>
</div>
<div id="drawer" ref={drawerRef}>
<div className="inner">
<div>
<button onClick={closeDrawer}>Close</button>
</div>
<div className="content" ref={drawerContentRef}></div>
</div>
</div>
</div>
</AgGridProvider>
);
};
const root = createRoot(document.getElementById("root"));
root.render(
<StrictMode>
<GridExample />
</StrictMode>,
);
.example-wrapper {
display: flex;
flex-direction: column;
height: 100%;
}
#myGrid {
flex: 1 1 0;
width: 100%;
}
.example-header {
margin-bottom: 10px;
}
#drawer.active,
#popup.active {
display: flex;
}
/* Base styles for the container */
#popup {
display: none; /* Hidden by default */
position: absolute;
top: 50%;
left: 50%;
transform: translate(-50%, -50%);
& .inner {
min-width: 300px;
}
& .content {
min-height: 200px;
}
}
#popup .inner {
border: 1px solid;
padding: 20px;
border-radius: 10px;
-webkit-font-smoothing: antialiased;
background-color: var(--example-background-color, white);
color: var(--example-text-color, black);
color-scheme: var(--example-color-scheme);
font-family: var(--example-font-family, Arial), sans-serif;
flex-direction: column;
}
/* Base styles for the container */
#drawer {
& .inner {
min-width: 300px;
}
& .content {
min-height: 200px;
}
position: fixed;
z-index: 2;
top: 54px;
bottom: 0;
width: 300px;
display: flex;
transform: translateX(-344px);
transition: transform 0.3s ease-in-out;
}
#drawer .content {
height: calc(100% - 90px);
}
#drawer .inner {
border: 1px solid;
padding: 20px;
border-radius: 10px;
-webkit-font-smoothing: antialiased;
background-color: var(--example-background-color, white);
color: var(--example-text-color, black);
color-scheme: var(--example-color-scheme);
font-family: var(--example-font-family, Arial), sans-serif;
flex-direction: column;
}
#drawer.active {
transform: translateX(0);
}
export interface IOlympicData {
athlete: string,
age: number,
country: string,
year: number,
date: string,
sport: string,
gold: number,
silver: number,
bronze: number,
total: number
} import { useState, useEffect } from 'react';
/**
* Fetch example Json data
* Not recommended for production use!
*/
export const useFetchJson = <T,>(url:string, limit?: number) => {
const [data, setData] = useState<T[]>();
const [loading, setLoading] = useState(true);
useEffect(() => {
// StrictMode runs this effect twice: drop the superseded run's response rather than applying both.
let cancelled = false;
const fetchData = async () => {
setLoading(true);
// Note error handling is omitted here for brevity
const response = await fetch(url);
const json = await response.json();
const data = limit ? json.slice(0, limit) : json;
if (cancelled) {
return;
}
setData(data);
setLoading(false);
};
fetchData();
return () => {
cancelled = true;
};
}, [url, limit]);
return { data, loading };
}; Providing Parameters to Tool Panels Copy Link
Parameters are passed to Tool Panels via the toolPanelParams object. For example, the following code snippet sets suppressRowGroups: true and suppressValues: true for the Columns Tool Panel.
const sideBar = useMemo(() => {
return {
toolPanels: [
{
id: 'columns',
labelDefault: 'Columns',
labelKey: 'columns',
iconKey: 'columns',
toolPanel: 'agColumnsToolPanel',
toolPanelParams: {
suppressRowGroups: true,
suppressValues: true,
}
}
]
};
}, []);
<AgGridReact sideBar={sideBar} />See the Columns Tool Panel documentation for the full list of possible parameters to this Tool Panel.
Animation Copy Link
By default, sidebar panels open and close instantly. You can enable a smooth slide animation using the Theming API parameter sideBarPanelAnimationDuration. Set it to a value in seconds:
const myTheme = themeQuartz.withParams({
sideBarPanelAnimationDuration: 0.3,
});The animation is automatically disabled for users who have requested reduced motion in their OS accessibility settings.
"use client";
import React, {
useCallback,
useMemo,
useRef,
useState,
StrictMode,
} from "react";
import { createRoot } from "react-dom/client";
import { AgGridReact, AgGridProvider } from "ag-grid-react";
import {
ClientSideRowModelModule,
ColDef,
ColGroupDef,
GridApi,
GridOptions,
ModuleRegistry,
NumberFilterModule,
SideBarDef,
TextFilterModule,
Theme,
enableDevValidations,
themeQuartz,
} from "ag-grid-community";
import {
ColumnsToolPanelModule,
NewFiltersToolPanelModule,
PivotModule,
SideBarModule,
} from "ag-grid-enterprise";
import { IOlympicData } from "./interfaces";
import { useFetchJson } from "./useFetchJson";
if (process.env.NODE_ENV !== "production") {
// Enable extended validations only for development
enableDevValidations();
}
const modules = [
ClientSideRowModelModule,
ColumnsToolPanelModule,
NewFiltersToolPanelModule,
TextFilterModule,
NumberFilterModule,
SideBarModule,
PivotModule,
];
const myTheme = themeQuartz.withParams({
sideBarPanelAnimationDuration: 0.3,
});
const GridExample = () => {
const containerStyle = useMemo(() => ({ width: "100%", height: "100%" }), []);
const gridStyle = useMemo(() => ({ height: "100%", width: "100%" }), []);
const [columnDefs, setColumnDefs] = useState<ColDef[]>([
{ field: "athlete" },
{ field: "country" },
{ field: "sport" },
{ field: "year" },
]);
const theme = useMemo<Theme | "legacy">(() => {
return myTheme;
}, []);
const defaultColDef = useMemo<ColDef>(() => {
return {
flex: 1,
filter: true,
sortable: true,
resizable: true,
};
}, []);
const sideBar = useMemo<
SideBarDef | string | string[] | boolean | null
>(() => {
return ["columns", "filters-new"];
}, []);
const { data, loading } = useFetchJson<IOlympicData>(
"https://www.ag-grid.com/example-assets/olympic-winners.json",
);
return (
<AgGridProvider modules={modules}>
<div style={containerStyle}>
<div style={gridStyle}>
<AgGridReact<IOlympicData>
rowData={data}
loading={loading}
columnDefs={columnDefs}
theme={theme}
defaultColDef={defaultColDef}
enableFilterHandlers={true}
sideBar={sideBar}
/>
</div>
</div>
</AgGridProvider>
);
};
const root = createRoot(document.getElementById("root")!);
root.render(
<StrictMode>
<GridExample />
</StrictMode>,
);
export interface IOlympicData {
athlete: string,
age: number,
country: string,
year: number,
date: string,
sport: string,
gold: number,
silver: number,
bronze: number,
total: number
} import { useState, useEffect } from 'react';
/**
* Fetch example Json data
* Not recommended for production use!
*/
export const useFetchJson = <T,>(url:string, limit?: number) => {
const [data, setData] = useState<T[]>();
const [loading, setLoading] = useState(true);
useEffect(() => {
// StrictMode runs this effect twice: drop the superseded run's response rather than applying both.
let cancelled = false;
const fetchData = async () => {
setLoading(true);
// Note error handling is omitted here for brevity
const response = await fetch(url);
const json = await response.json();
const data = limit ? json.slice(0, limit) : json;
if (cancelled) {
return;
}
setData(data);
setLoading(false);
};
fetchData();
return () => {
cancelled = true;
};
}, [url, limit]);
return { data, loading };
}; Side Bar API Copy Link
The Side Bar state can be saved and restored as part of Grid State.
The list below details all the API methods relevant to the Tool Panel.
Returns the current side bar configuration. If a shortcut was used, returns the detailed long form. |
Show/hide the entire side bar, including any visible panel and the tab buttons. |
Returns true if the side bar is visible. |
Sets the side bar position relative to the grid. Possible values are 'left' or 'right'. |
Opens a particular tool panel. Provide the ID of the tool panel to open.
Optionally, provide a parent element to attach the tool panel to. |
Closes the currently open tool panel (if any). |
Returns the ID of the currently shown tool panel if any, otherwise null. |
Returns true if the tool panel is showing, otherwise false. |
Force refreshes all tool panels by calling their refresh method. |
Gets the tool panel instance corresponding to the supplied id. |
The example below demonstrates different usages of the Tool Panel API methods. The following can be noted:
- Initially the Side Bar is not visible as
sideBar.hiddenByDefault=true. - Visibility Buttons: These toggle visibility of the Tool Panel. Note that when you make
visible=false, the entire Tool Panel is hidden including the tabs. Make sure the Tool Panel is left visible before testing the other API features so you can see the impact. - Open / Close Buttons: These open and close different Tool Panel items.
- Reset Buttons: These reset the Tool Panel to a new configuration. Notice that shortcuts are provided as configuration however
getSideBar()returns back the long form. - Position Buttons: These change the position of the Side Bar relative to the grid.
- The
get*buttons log data to the developer console.
("use client");
import React, {
useCallback,
useMemo,
useRef,
useState,
StrictMode,
} from "react";
import { createRoot } from "react-dom/client";
import { AgGridReact, AgGridProvider } from "ag-grid-react";
import "./style.css";
import {
AutoGroupColumnDef,
ClientSideRowModelModule,
ColDef,
ColGroupDef,
GridApi,
GridOptions,
ModuleRegistry,
NumberFilterModule,
SideBarDef,
TextFilterModule,
ToolPanelSizeChangedEvent,
ToolPanelVisibleChangedEvent,
enableDevValidations,
} from "ag-grid-community";
import {
ColumnsToolPanelModule,
FiltersToolPanelModule,
PivotModule,
SetFilterModule,
} from "ag-grid-enterprise";
import { IOlympicData } from "./interfaces";
import { useFetchJson } from "./useFetchJson";
if (process.env.NODE_ENV !== "production") {
// Enable extended validations only for development
enableDevValidations();
}
const modules = [
NumberFilterModule,
ClientSideRowModelModule,
ColumnsToolPanelModule,
FiltersToolPanelModule,
SetFilterModule,
PivotModule,
TextFilterModule,
];
const GridExample = () => {
const gridRef = useRef<AgGridReact<IOlympicData>>(null);
const containerStyle = useMemo(() => ({ width: "100%", height: "100%" }), []);
const gridStyle = useMemo(() => ({ height: "100%", width: "100%" }), []);
const [columnDefs, setColumnDefs] = useState<ColDef[]>([
{ field: "athlete", filter: "agTextColumnFilter", minWidth: 200 },
{ field: "age" },
{ field: "country", minWidth: 200 },
{ field: "year" },
{ field: "date", minWidth: 160 },
{ field: "gold" },
{ field: "silver" },
{ field: "bronze" },
{ field: "total" },
]);
const defaultColDef = useMemo<ColDef>(() => {
return {
flex: 1,
minWidth: 100,
// allow every column to be aggregated
enableValue: true,
// allow every column to be grouped
enableRowGroup: true,
// allow every column to be pivoted
enablePivot: true,
filter: true,
};
}, []);
const autoGroupColumnDef = useMemo<AutoGroupColumnDef>(() => {
return {
minWidth: 200,
};
}, []);
const sideBar = useMemo<
SideBarDef | string | string[] | boolean | null
>(() => {
return {
toolPanels: [
{
id: "columns",
labelDefault: "Columns",
labelKey: "columns",
iconKey: "columns",
toolPanel: "agColumnsToolPanel",
},
{
id: "filters",
labelDefault: "Filters",
labelKey: "filters",
iconKey: "filter",
toolPanel: "agFiltersToolPanel",
},
],
defaultToolPanel: "filters",
hiddenByDefault: true,
};
}, []);
const { data, loading } = useFetchJson<IOlympicData>(
"https://www.ag-grid.com/example-assets/olympic-winners.json",
);
const onToolPanelVisibleChanged = useCallback(
(event: ToolPanelVisibleChangedEvent) => {
console.log("toolPanelVisibleChanged", event);
},
[],
);
const onToolPanelSizeChanged = useCallback(
(event: ToolPanelSizeChangedEvent) => {
console.log("toolPanelSizeChanged", event);
},
[],
);
const setSideBarVisible = useCallback((value: boolean) => {
gridRef.current!.api.setSideBarVisible(value);
}, []);
const isSideBarVisible = useCallback(() => {
console.log(gridRef.current!.api.isSideBarVisible());
}, []);
const openToolPanel = useCallback((key: string) => {
gridRef.current!.api.openToolPanel(key);
}, []);
const closeToolPanel = useCallback(() => {
gridRef.current!.api.closeToolPanel();
}, []);
const getOpenedToolPanel = useCallback(() => {
console.log(gridRef.current!.api.getOpenedToolPanel());
}, []);
const setSideBar = useCallback(
(def: SideBarDef | string | string[] | boolean) => {
gridRef.current!.api.setGridOption("sideBar", def);
},
[],
);
const getSideBar = useCallback(() => {
const sideBar = gridRef.current!.api.getSideBar();
console.log(JSON.stringify(sideBar));
console.log(sideBar);
}, []);
const setSideBarPosition = useCallback((position: "left" | "right") => {
gridRef.current!.api.setSideBarPosition(position);
}, []);
return (
<AgGridProvider modules={modules}>
<div style={containerStyle}>
<div className="parent-div">
<div className="api-panel">
<div className="api-column">
Visibility
<button onClick={() => setSideBarVisible(true)}>
setSideBarVisible(true)
</button>
<button onClick={() => setSideBarVisible(false)}>
setSideBarVisible(false)
</button>
<button onClick={isSideBarVisible}>isSideBarVisible()</button>
</div>
<div className="api-column">
Open & Close
<button onClick={() => openToolPanel("columns")}>
openToolPanel('columns')
</button>
<button onClick={() => openToolPanel("filters")}>
openToolPanel('filters')
</button>
<button onClick={closeToolPanel}>closeToolPanel()</button>
<button onClick={getOpenedToolPanel}>getOpenedToolPanel()</button>
</div>
<div className="api-column">
Reset
<button onClick={() => setSideBar(["filters", "columns"])}>
setSideBar(['filters','columns'])
</button>
<button onClick={() => setSideBar("columns")}>
setSideBar('columns')
</button>
<button onClick={getSideBar}>getSideBar()</button>
</div>
<div className="api-column">
Position
<button onClick={() => setSideBarPosition("left")}>
setSideBarPosition('left')
</button>
<button onClick={() => setSideBarPosition("right")}>
setSideBarPosition('right')
</button>
</div>
</div>
<div style={gridStyle} className="grid-div">
<AgGridReact<IOlympicData>
ref={gridRef}
rowData={data}
loading={loading}
columnDefs={columnDefs}
defaultColDef={defaultColDef}
autoGroupColumnDef={autoGroupColumnDef}
sideBar={sideBar}
onToolPanelVisibleChanged={onToolPanelVisibleChanged}
onToolPanelSizeChanged={onToolPanelSizeChanged}
/>
</div>
</div>
</div>
</AgGridProvider>
);
};
const root = createRoot(document.getElementById("root")!);
root.render(
<StrictMode>
<GridExample />
</StrictMode>,
);
.api-panel {
display: flex;
flex-direction: row;
flex-wrap: wrap;
font-family: Verdana, Geneva, Tahoma, sans-serif;
font-size: 13px;
}
.api-column {
padding: 0px 5px 5px;
text-align: center;
width: 215px;
max-height: 200px;
}
.api-column button {
width: 100%;
}
.api-column button:first-child {
margin-top: 5px;
}
.api-panel button {
margin: 2px;
}
.grid-div {
height: 100%;
}
.parent-div {
height: 100%;
display: grid;
grid-template-rows: auto 1fr;
}
export interface IOlympicData {
athlete: string,
age: number,
country: string,
year: number,
date: string,
sport: string,
gold: number,
silver: number,
bronze: number,
total: number
} import { useState, useEffect } from 'react';
/**
* Fetch example Json data
* Not recommended for production use!
*/
export const useFetchJson = <T,>(url:string, limit?: number) => {
const [data, setData] = useState<T[]>();
const [loading, setLoading] = useState(true);
useEffect(() => {
// StrictMode runs this effect twice: drop the superseded run's response rather than applying both.
let cancelled = false;
const fetchData = async () => {
setLoading(true);
// Note error handling is omitted here for brevity
const response = await fetch(url);
const json = await response.json();
const data = limit ? json.slice(0, limit) : json;
if (cancelled) {
return;
}
setData(data);
setLoading(false);
};
fetchData();
return () => {
cancelled = true;
};
}, [url, limit]);
return { data, loading };
};

This section covers how to configure the Side Bar which contains Tool Panels.
Configuring the Side Bar Copy Link
The Side Bar is configured using the grid property sideBar. The property takes multiple forms to allow easy configuration or more advanced configuration. The different forms for the sideBar property are as follows:
| Type | Description |
|---|---|
undefined / null | No Side Bar provided. |
boolean | Set to true to display the Side Bar with default configuration. |
string / string[] | Set to 'columns', 'filters' or 'filters-new' to display the Side Bar with just one of Columns, Filters or New Filters Tool Panels or an array of some or all of these values. |
SideBarDef(long form) | An object of type SideBarDef (explained below) to allow detailed configuration of the Side Bar. Use this to configure the provided Tool Panels (e.g. pass parameters to the columns or filters panel) or to include custom Tool Panels. |
Boolean Configuration Copy Link
The default Side Bar contains the Columns and Filters Tool Panels. To use the default Side Bar, set the grid property sideBar=true. The Columns panel will be open by default.
The default configuration doesn't allow customisation of the Tool Panels.
import { Component } from "@angular/core";
import { HttpClient } from "@angular/common/http";
import { AgGridAngular } from "ag-grid-angular";
import {
AutoGroupColumnDef,
ClientSideRowModelModule,
ColDef,
ColGroupDef,
GridApi,
GridOptions,
GridReadyEvent,
ModuleRegistry,
NumberFilterModule,
SideBarDef,
TextFilterModule,
enableDevValidations,
} from "ag-grid-community";
import {
ColumnsToolPanelModule,
FiltersToolPanelModule,
PivotModule,
SetFilterModule,
} from "ag-grid-enterprise";
if (process.env.NODE_ENV !== "production") {
// Enable extended validations only for development
enableDevValidations();
}
ModuleRegistry.registerModules([
NumberFilterModule,
ClientSideRowModelModule,
ColumnsToolPanelModule,
FiltersToolPanelModule,
SetFilterModule,
PivotModule,
TextFilterModule,
]);
import { IOlympicData } from "./interfaces";
@Component({
selector: "my-app",
standalone: true,
imports: [AgGridAngular],
template: `<ag-grid-angular
style="width: 100%; height: 100%;"
[columnDefs]="columnDefs"
[defaultColDef]="defaultColDef"
[autoGroupColumnDef]="autoGroupColumnDef"
[sideBar]="true"
[rowData]="rowData"
(gridReady)="onGridReady($event)"
/> `,
})
export class AppComponent {
columnDefs: ColDef[] = [
{ field: "athlete", filter: "agTextColumnFilter", minWidth: 200 },
{ field: "age" },
{ field: "country", minWidth: 180 },
{ field: "year" },
{ field: "date", minWidth: 150 },
{ field: "gold" },
{ field: "silver" },
{ field: "bronze" },
{ field: "total" },
];
defaultColDef: ColDef = {
flex: 1,
minWidth: 100,
// allow every column to be aggregated
enableValue: true,
// allow every column to be grouped
enableRowGroup: true,
// allow every column to be pivoted
enablePivot: true,
filter: true,
};
autoGroupColumnDef: AutoGroupColumnDef = {
minWidth: 200,
};
rowData!: IOlympicData[];
constructor(private http: HttpClient) {}
onGridReady(params: GridReadyEvent<IOlympicData>) {
this.http
.get<
IOlympicData[]
>("https://www.ag-grid.com/example-assets/olympic-winners.json")
.subscribe((data) => (this.rowData = data));
}
}
import '@angular/compiler';
import { provideHttpClient } from '@angular/common/http';
import { enableProdMode } from '@angular/core';
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
if (new URLSearchParams(window.location.search).get('prod') !== 'false') {
enableProdMode();
}
const app = bootstrapApplication(AppComponent, {
providers: [provideHttpClient()],
});
export interface IOlympicData {
athlete: string,
age: number,
country: string,
year: number,
date: string,
sport: string,
gold: number,
silver: number,
bronze: number,
total: number
} String Configuration Copy Link
To display just one of the provided Tool Panels, set either sideBar='columns', sideBar='filters' or sideBar='filters-new'. This will display the desired item with default configuration. Alternatively pass some or all of these values as a string[], i.e sideBar=['columns','filters', 'filters-new'].
The example below demonstrates using the string configuration. Note the following:
- The grid property
sideBaris set to'filters'. - The Side Bar is displayed showing only the Filters panel.
import { Component } from "@angular/core";
import { HttpClient } from "@angular/common/http";
import { AgGridAngular } from "ag-grid-angular";
import {
ClientSideRowModelModule,
ColDef,
ColGroupDef,
GridApi,
GridOptions,
GridReadyEvent,
ModuleRegistry,
NumberFilterModule,
SideBarDef,
TextFilterModule,
enableDevValidations,
} from "ag-grid-community";
import {
ColumnsToolPanelModule,
FiltersToolPanelModule,
PivotModule,
SetFilterModule,
} from "ag-grid-enterprise";
if (process.env.NODE_ENV !== "production") {
// Enable extended validations only for development
enableDevValidations();
}
ModuleRegistry.registerModules([
NumberFilterModule,
ClientSideRowModelModule,
ColumnsToolPanelModule,
FiltersToolPanelModule,
SetFilterModule,
PivotModule,
TextFilterModule,
]);
import { IOlympicData } from "./interfaces";
@Component({
selector: "my-app",
standalone: true,
imports: [AgGridAngular],
template: `<ag-grid-angular
style="width: 100%; height: 100%;"
[columnDefs]="columnDefs"
[defaultColDef]="defaultColDef"
[sideBar]="sideBar"
[rowData]="rowData"
(gridReady)="onGridReady($event)"
/> `,
})
export class AppComponent {
columnDefs: ColDef[] = [
{ field: "athlete", filter: "agTextColumnFilter", minWidth: 200 },
{ field: "age" },
{ field: "country", minWidth: 180 },
{ field: "year" },
{ field: "date", minWidth: 150 },
{ field: "gold" },
{ field: "silver" },
{ field: "bronze" },
{ field: "total" },
];
defaultColDef: ColDef = {
flex: 1,
minWidth: 100,
// allow every column to be aggregated
enableValue: true,
// allow every column to be grouped
enableRowGroup: true,
// allow every column to be pivoted
enablePivot: true,
filter: true,
};
sideBar: SideBarDef | string | string[] | boolean | null = "filters";
rowData!: IOlympicData[];
constructor(private http: HttpClient) {}
onGridReady(params: GridReadyEvent<IOlympicData>) {
this.http
.get<
IOlympicData[]
>("https://www.ag-grid.com/example-assets/olympic-winners.json")
.subscribe((data) => (this.rowData = data));
}
}
import '@angular/compiler';
import { provideHttpClient } from '@angular/common/http';
import { enableProdMode } from '@angular/core';
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
if (new URLSearchParams(window.location.search).get('prod') !== 'false') {
enableProdMode();
}
const app = bootstrapApplication(AppComponent, {
providers: [provideHttpClient()],
});
export interface IOlympicData {
athlete: string,
age: number,
country: string,
year: number,
date: string,
sport: string,
gold: number,
silver: number,
bronze: number,
total: number
} SideBarDef Configuration Copy Link
The previous configurations are shortcuts for the full fledged configuration using a SideBarDef object. For full control over the configuration, you must provide a SideBarDef object.
Properties available on the SideBarDef interface.
A list of all the panels to place in the side bar. The panels will be displayed in the provided order from top to bottom.
|
The panel (identified by ID) to open by default. If none specified, the side bar is initially displayed closed. |
To hide the side bar by default, set this to true. If left undefined the side bar will be shown. |
Sets the side bar position relative to the grid. |
To hide the side bar buttons by default set this to true. If left undefined the buttons will be shown. This is useful if you want to show a tool panel without showing the buttons. |
The toolPanels property follows the ToolPanelDef interface:
Properties available on the ToolPanelDef interface.
The unique ID for this panel. Used in the API and elsewhere to refer to the panel. |
The key used for localisation for displaying the label. The label is displayed in the tab button. |
The default label if labelKey is missing or does not map to valid text through localisation. |
The min width of the tool panel. |
The max width of the tool panel. |
The initial width of the tool panel. |
The key of the icon to be used as a graphical aid beside the label in the side bar. |
The tool panel component to use as the panel. The provided panels use components agColumnsToolPanel, agFiltersToolPanel and agNewFiltersToolPanel. To provide your own custom panel component, you reference it here.
|
Customise the parameters provided to the toolPanel component. |
DOM element to use as the parent for the tool panel to allow it to appear outside the grid. Set to null or omit the property for tool panel to appear inside the grid.
|
The following snippet shows configuring the Tool Panel using a SideBarDef object:
<ag-grid-angular
[sideBar]="sideBar"
/* other grid options ... */ />
this.sideBar = {
toolPanels: [
{
id: 'columns',
labelDefault: 'Columns',
labelKey: 'columns',
iconKey: 'columns',
toolPanel: 'agColumnsToolPanel',
minWidth: 225,
maxWidth: 225,
width: 225
},
{
id: 'filters',
labelDefault: 'Filters',
labelKey: 'filters',
iconKey: 'filter',
toolPanel: 'agFiltersToolPanel',
minWidth: 180,
maxWidth: 400,
width: 250
}
],
position: 'left',
defaultToolPanel: 'filters',
};The snippet above is demonstrated in the following example:
import { Component } from "@angular/core";
import { HttpClient } from "@angular/common/http";
import { AgGridAngular } from "ag-grid-angular";
import {
AutoGroupColumnDef,
ClientSideRowModelModule,
ColDef,
ColGroupDef,
GridApi,
GridOptions,
GridReadyEvent,
ModuleRegistry,
NumberFilterModule,
SideBarDef,
TextFilterModule,
enableDevValidations,
} from "ag-grid-community";
import {
ColumnsToolPanelModule,
FiltersToolPanelModule,
PivotModule,
SetFilterModule,
} from "ag-grid-enterprise";
if (process.env.NODE_ENV !== "production") {
// Enable extended validations only for development
enableDevValidations();
}
ModuleRegistry.registerModules([
NumberFilterModule,
ClientSideRowModelModule,
ColumnsToolPanelModule,
FiltersToolPanelModule,
SetFilterModule,
PivotModule,
TextFilterModule,
]);
import { IOlympicData } from "./interfaces";
@Component({
selector: "my-app",
standalone: true,
imports: [AgGridAngular],
template: `<ag-grid-angular
style="width: 100%; height: 100%;"
[columnDefs]="columnDefs"
[defaultColDef]="defaultColDef"
[autoGroupColumnDef]="autoGroupColumnDef"
[sideBar]="sideBar"
[rowData]="rowData"
(gridReady)="onGridReady($event)"
/> `,
})
export class AppComponent {
columnDefs: ColDef[] = [
{ field: "athlete", filter: "agTextColumnFilter", minWidth: 200 },
{ field: "age" },
{ field: "country", minWidth: 180 },
{ field: "year" },
{ field: "date", minWidth: 150 },
{ field: "gold" },
{ field: "silver" },
{ field: "bronze" },
{ field: "total" },
];
defaultColDef: ColDef = {
flex: 1,
minWidth: 100,
// allow every column to be aggregated
enableValue: true,
// allow every column to be grouped
enableRowGroup: true,
// allow every column to be pivoted
enablePivot: true,
filter: true,
};
autoGroupColumnDef: AutoGroupColumnDef = {
minWidth: 200,
};
sideBar: SideBarDef | string | string[] | boolean | null = {
toolPanels: [
{
id: "columns",
labelDefault: "Columns",
labelKey: "columns",
iconKey: "columns",
toolPanel: "agColumnsToolPanel",
minWidth: 225,
width: 225,
maxWidth: 225,
},
{
id: "filters",
labelDefault: "Filters",
labelKey: "filters",
iconKey: "filter",
toolPanel: "agFiltersToolPanel",
minWidth: 180,
maxWidth: 400,
width: 250,
},
],
position: "left",
defaultToolPanel: "filters",
};
rowData!: IOlympicData[];
constructor(private http: HttpClient) {}
onGridReady(params: GridReadyEvent<IOlympicData>) {
this.http
.get<
IOlympicData[]
>("https://www.ag-grid.com/example-assets/olympic-winners.json")
.subscribe((data) => (this.rowData = data));
}
}
import '@angular/compiler';
import { provideHttpClient } from '@angular/common/http';
import { enableProdMode } from '@angular/core';
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
if (new URLSearchParams(window.location.search).get('prod') !== 'false') {
enableProdMode();
}
const app = bootstrapApplication(AppComponent, {
providers: [provideHttpClient()],
});
export interface IOlympicData {
athlete: string,
age: number,
country: string,
year: number,
date: string,
sport: string,
gold: number,
silver: number,
bronze: number,
total: number
} Calling setSideBarVisible(true) when sideBarDef.hideButtons is set to true and no tool panel is open will not display anything.
The Popup Parent must be set to an element that contains both the tool panel parent and the grid to ensure all popups (e.g., Columns Tool Panel context menus) are fully visible.
Configuration Shortcuts Copy Link
The boolean and string configurations are shortcuts for more detailed configurations. When you use a shortcut the grid replaces it with the equivalent long form of the configuration by building the equivalent SideBarDef.
The following code snippets show an example of the boolean shortcut and the equivalent SideBarDef long form.
<ag-grid-angular
[sideBar]="sideBar"
/* other grid options ... */ />
// shortcut
this.sideBar = true;<ag-grid-angular
[sideBar]="sideBar"
/* other grid options ... */ />
// equivalent detailed long form
this.sideBar = {
toolPanels: [
{
id: 'columns',
labelDefault: 'Columns',
labelKey: 'columns',
iconKey: 'columns',
toolPanel: 'agColumnsToolPanel',
},
{
id: 'filters',
labelDefault: 'Filters',
labelKey: 'filters',
iconKey: 'filter',
toolPanel: 'agFiltersToolPanel',
}
],
defaultToolPanel: 'columns',
};The following code snippets show an example of the string shortcut and the equivalent SideBarDef long form.
<ag-grid-angular
[sideBar]="sideBar"
/* other grid options ... */ />
// shortcut
this.sideBar = 'filters';<ag-grid-angular
[sideBar]="sideBar"
/* other grid options ... */ />
// equivalent detailed long form
this.sideBar = {
toolPanels: [
{
id: 'filters',
labelDefault: 'Filters',
labelKey: 'filters',
iconKey: 'filter',
toolPanel: 'agFiltersToolPanel',
}
],
defaultToolPanel: 'filters',
};You can also use shortcuts inside the sideBar.toolPanels array for specifying the Columns and Filters items.
<ag-grid-angular
[sideBar]="sideBar"
/* other grid options ... */ />
// shortcut
this.sideBar = {
toolPanels: ['columns', 'filters']
};<ag-grid-angular
[sideBar]="sideBar"
/* other grid options ... */ />
// equivalent detailed long form
this.sideBar = {
toolPanels: [
{
id: 'columns',
labelDefault: 'Columns',
labelKey: 'columns',
iconKey: 'columns',
toolPanel: 'agColumnsToolPanel',
},
{
id: 'filters',
labelDefault: 'Filters',
labelKey: 'filters',
iconKey: 'filter',
toolPanel: 'agFiltersToolPanel',
}
]
}; Side Bar Customisation Copy Link
If you are using the long form (providing a SideBarDef object) then it is possible to customise. The example below changes the filter label and icon.
import { Component } from "@angular/core";
import { HttpClient } from "@angular/common/http";
import { AgGridAngular } from "ag-grid-angular";
import {
AutoGroupColumnDef,
ClientSideRowModelModule,
ColDef,
ColGroupDef,
GridApi,
GridOptions,
GridReadyEvent,
ModuleRegistry,
NumberFilterModule,
SideBarDef,
TextFilterModule,
enableDevValidations,
} from "ag-grid-community";
import {
ColumnsToolPanelModule,
FiltersToolPanelModule,
PivotModule,
SetFilterModule,
} from "ag-grid-enterprise";
if (process.env.NODE_ENV !== "production") {
// Enable extended validations only for development
enableDevValidations();
}
ModuleRegistry.registerModules([
NumberFilterModule,
ClientSideRowModelModule,
ColumnsToolPanelModule,
FiltersToolPanelModule,
SetFilterModule,
PivotModule,
TextFilterModule,
]);
import { IOlympicData } from "./interfaces";
@Component({
selector: "my-app",
standalone: true,
imports: [AgGridAngular],
template: `<ag-grid-angular
style="width: 100%; height: 100%;"
[columnDefs]="columnDefs"
[defaultColDef]="defaultColDef"
[autoGroupColumnDef]="autoGroupColumnDef"
[sideBar]="sideBar"
[rowData]="rowData"
(gridReady)="onGridReady($event)"
/> `,
})
export class AppComponent {
columnDefs: ColDef[] = [
{ field: "athlete", filter: "agTextColumnFilter", minWidth: 200 },
{ field: "age" },
{ field: "country", minWidth: 180 },
{ field: "year" },
{ field: "date", minWidth: 150 },
{ field: "gold" },
{ field: "silver" },
{ field: "bronze" },
{ field: "total" },
];
defaultColDef: ColDef = {
flex: 1,
minWidth: 100,
// allow every column to be aggregated
enableValue: true,
// allow every column to be grouped
enableRowGroup: true,
// allow every column to be pivoted
enablePivot: true,
filter: true,
};
autoGroupColumnDef: AutoGroupColumnDef = {
minWidth: 200,
};
sideBar: SideBarDef | string | string[] | boolean | null = {
toolPanels: [
"columns",
{
id: "filters",
labelKey: "filters",
labelDefault: "Filters",
iconKey: "menu",
toolPanel: "agFiltersToolPanel",
},
{
id: "filters 2",
labelKey: "filters",
labelDefault: "Filters XXXXXXXX",
iconKey: "filter",
toolPanel: "agFiltersToolPanel",
},
],
defaultToolPanel: "filters",
};
rowData!: IOlympicData[];
constructor(private http: HttpClient) {}
onGridReady(params: GridReadyEvent<IOlympicData>) {
this.http
.get<
IOlympicData[]
>("https://www.ag-grid.com/example-assets/olympic-winners.json")
.subscribe((data) => (this.rowData = data));
}
}
import '@angular/compiler';
import { provideHttpClient } from '@angular/common/http';
import { enableProdMode } from '@angular/core';
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
if (new URLSearchParams(window.location.search).get('prod') !== 'false') {
enableProdMode();
}
const app = bootstrapApplication(AppComponent, {
providers: [provideHttpClient()],
});
export interface IOlympicData {
athlete: string,
age: number,
country: string,
year: number,
date: string,
sport: string,
gold: number,
silver: number,
bronze: number,
total: number
} Tool Panel Parent Copy Link
By default, Tool Panels are rendered inside the Side Bar. If you want to render Tool Panels in a different location, you can set the parent property in the ToolPanelDef. This is useful if you want to render Tool Panel in a different part of your application, such as a popup window or a separate section of your page.
To ensure correct panel sizing, AG Grid adds a CSS class to the parent element. If your component also sets the parent class it may overwrite this, so include the ag-tool-panel-external class when setting the parent class:
<div #toolPanelParent class="your-app-class ag-tool-panel-external"></div>The Popup Parent must also be set to an element that contains both the Tool Panel parent and the grid.
You can also provide a parent for the tool panel in the call to openToolPanel method:
Opens a particular tool panel. Provide the ID of the tool panel to open.
Optionally, provide a parent element to attach the tool panel to. |
import { HttpClient } from "@angular/common/http";
import { Component, ElementRef, ViewChild } from "@angular/core";
import { AgGridAngular } from "ag-grid-angular";
import type {
ColDef,
GridApi,
GridReadyEvent,
SideBarDef,
ToolPanelDef,
} from "ag-grid-community";
import {
ClientSideRowModelModule,
ModuleRegistry,
NumberFilterModule,
TextFilterModule,
enableDevValidations,
} from "ag-grid-community";
import {
ColumnsToolPanelModule,
NewFiltersToolPanelModule,
PivotModule,
SetFilterModule,
} from "ag-grid-enterprise";
import { IOlympicData } from "./interfaces";
import "./styles.css";
if (process.env.NODE_ENV !== "production") {
// Enable extended validations only for development
enableDevValidations();
}
ModuleRegistry.registerModules([
NumberFilterModule,
ClientSideRowModelModule,
ColumnsToolPanelModule,
NewFiltersToolPanelModule,
SetFilterModule,
PivotModule,
TextFilterModule,
]);
@Component({
selector: "my-app",
standalone: true,
imports: [AgGridAngular],
template: `<div id="wrapper" class="example-wrapper">
<div class="example-header">
<button (click)="openPopup()">Open Columns Tool Panel</button>
<button (click)="openDrawer()">Open Filters Tool Panel</button>
</div>
<ag-grid-angular
style="width: 100%; height: 100%;"
[popupParent]="popupParent"
[enableFilterHandlers]="true"
[columnDefs]="columnDefs"
[defaultColDef]="defaultColDef"
[autoGroupColumnDef]="autoGroupColumnDef"
[sideBar]="sideBar"
[rowData]="rowData"
(gridReady)="onGridReady($event)"
/>
</div>
<div id="popup" #popup>
<div class="inner">
<div><button (click)="closePopup()">Close</button></div>
<div class="content" #popupContent></div>
</div>
</div>
<div id="drawer" #drawer>
<div class="inner">
<div><button (click)="closeDrawer()">Close</button></div>
<div class="content" #drawerContent></div>
</div>
</div> `,
})
export class AppComponent {
@ViewChild("popup", { read: ElementRef })
public popupRef!: ElementRef<HTMLElement>;
@ViewChild("popupContent", { read: ElementRef })
public popupContentRef!: ElementRef<HTMLElement>;
@ViewChild("drawer", { read: ElementRef })
public drawerRef!: ElementRef<HTMLElement>;
@ViewChild("drawerContent", { read: ElementRef })
public drawerContentRef!: ElementRef<HTMLElement>;
columnsToolPanel: ToolPanelDef = {
id: "columns",
labelDefault: "Popup",
labelKey: "columns",
iconKey: "columnsToolPanel",
toolPanel: "agColumnsToolPanel",
toolPanelParams: {
suppressRowGroups: true,
suppressValues: true,
suppressPivotMode: true,
},
};
filtersToolPanel: ToolPanelDef = {
id: "filters",
labelDefault: "Drawer",
labelKey: "filters",
iconKey: "filter",
toolPanel: "agNewFiltersToolPanel",
};
sideBar: SideBarDef = {
hideButtons: true,
hiddenByDefault: true,
};
private gridApi!: GridApi<IOlympicData>;
popupParent: HTMLElement = document.body;
columnDefs: ColDef[] = [
{ field: "athlete", filter: "agTextColumnFilter", minWidth: 200 },
{ field: "country", minWidth: 180 },
{ field: "date", minWidth: 150 },
{ field: "gold", minWidth: 150 },
{ field: "silver", minWidth: 150 },
];
defaultColDef: ColDef = { flex: 1, minWidth: 100, filter: true };
autoGroupColumnDef: ColDef = { minWidth: 200 };
rowData!: IOlympicData[];
constructor(private http: HttpClient) {}
ngAfterViewInit() {
this.columnsToolPanel.parent = this.popupContentRef
?.nativeElement as HTMLElement;
this.sideBar.toolPanels = [this.columnsToolPanel, this.filtersToolPanel];
this.sideBar = { ...this.sideBar };
}
closePopup() {
const drawer = this.popupRef.nativeElement;
drawer.classList.toggle("active", false);
this.gridApi.closeToolPanel();
}
closeDrawer() {
const drawer = this.drawerRef.nativeElement;
drawer.classList.toggle("active", false);
this.gridApi.closeToolPanel();
}
openPopup() {
this.closeDrawer();
const popup = this.popupRef.nativeElement;
popup.classList.toggle("active", true);
this.gridApi.openToolPanel(this.columnsToolPanel.id);
}
openDrawer() {
this.closePopup();
const drawer = this.drawerRef.nativeElement;
drawer.classList.toggle("active", true);
this.gridApi.openToolPanel(
this.filtersToolPanel.id,
this.drawerContentRef?.nativeElement as HTMLElement,
);
}
onGridReady(params: GridReadyEvent<IOlympicData>) {
this.gridApi = params.api;
this.http
.get<
IOlympicData[]
>("https://www.ag-grid.com/example-assets/olympic-winners.json")
.subscribe((data) => (this.rowData = data));
}
}
.example-wrapper {
display: flex;
flex-direction: column;
height: 100%;
}
#myGrid {
flex: 1 1 0;
width: 100%;
}
.example-header {
margin-bottom: 10px;
}
#drawer.active,
#popup.active {
display: flex;
}
/* Base styles for the container */
#popup {
display: none; /* Hidden by default */
position: absolute;
top: 50%;
left: 50%;
transform: translate(-50%, -50%);
& .inner {
min-width: 300px;
}
& .content {
min-height: 200px;
}
}
#popup .inner {
border: 1px solid;
padding: 20px;
border-radius: 10px;
-webkit-font-smoothing: antialiased;
background-color: var(--example-background-color, white);
color: var(--example-text-color, black);
color-scheme: var(--example-color-scheme);
font-family: var(--example-font-family, Arial), sans-serif;
flex-direction: column;
}
/* Base styles for the container */
#drawer {
& .inner {
min-width: 300px;
}
& .content {
min-height: 200px;
}
position: fixed;
z-index: 2;
top: 54px;
bottom: 0;
width: 300px;
display: flex;
transform: translateX(-344px);
transition: transform 0.3s ease-in-out;
}
#drawer .content {
height: calc(100% - 90px);
}
#drawer .inner {
border: 1px solid;
padding: 20px;
border-radius: 10px;
-webkit-font-smoothing: antialiased;
background-color: var(--example-background-color, white);
color: var(--example-text-color, black);
color-scheme: var(--example-color-scheme);
font-family: var(--example-font-family, Arial), sans-serif;
flex-direction: column;
}
#drawer.active {
transform: translateX(0);
}
export interface IOlympicData {
athlete: string,
age: number,
country: string,
year: number,
date: string,
sport: string,
gold: number,
silver: number,
bronze: number,
total: number
} import '@angular/compiler';
import { provideHttpClient } from '@angular/common/http';
import { enableProdMode } from '@angular/core';
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
if (new URLSearchParams(window.location.search).get('prod') !== 'false') {
enableProdMode();
}
const app = bootstrapApplication(AppComponent, {
providers: [provideHttpClient()],
});
Providing Parameters to Tool Panels Copy Link
Parameters are passed to Tool Panels via the toolPanelParams object. For example, the following code snippet sets suppressRowGroups: true and suppressValues: true for the Columns Tool Panel.
<ag-grid-angular
[sideBar]="sideBar"
/* other grid options ... */ />
this.sideBar = {
toolPanels: [
{
id: 'columns',
labelDefault: 'Columns',
labelKey: 'columns',
iconKey: 'columns',
toolPanel: 'agColumnsToolPanel',
toolPanelParams: {
suppressRowGroups: true,
suppressValues: true,
}
}
]
};See the Columns Tool Panel documentation for the full list of possible parameters to this Tool Panel.
Animation Copy Link
By default, sidebar panels open and close instantly. You can enable a smooth slide animation using the Theming API parameter sideBarPanelAnimationDuration. Set it to a value in seconds:
const myTheme = themeQuartz.withParams({
sideBarPanelAnimationDuration: 0.3,
});The animation is automatically disabled for users who have requested reduced motion in their OS accessibility settings.
import { Component } from "@angular/core";
import { HttpClient } from "@angular/common/http";
import { AgGridAngular } from "ag-grid-angular";
import {
ClientSideRowModelModule,
ColDef,
ColGroupDef,
GridApi,
GridOptions,
GridReadyEvent,
ModuleRegistry,
NumberFilterModule,
SideBarDef,
TextFilterModule,
Theme,
enableDevValidations,
themeQuartz,
} from "ag-grid-community";
import {
ColumnsToolPanelModule,
NewFiltersToolPanelModule,
PivotModule,
SideBarModule,
} from "ag-grid-enterprise";
if (process.env.NODE_ENV !== "production") {
// Enable extended validations only for development
enableDevValidations();
}
ModuleRegistry.registerModules([
ClientSideRowModelModule,
ColumnsToolPanelModule,
NewFiltersToolPanelModule,
TextFilterModule,
NumberFilterModule,
SideBarModule,
PivotModule,
]);
import { IOlympicData } from "./interfaces";
@Component({
selector: "my-app",
standalone: true,
imports: [AgGridAngular],
template: `<ag-grid-angular
style="width: 100%; height: 100%;"
[columnDefs]="columnDefs"
[theme]="theme"
[defaultColDef]="defaultColDef"
[enableFilterHandlers]="true"
[sideBar]="sideBar"
[rowData]="rowData"
(gridReady)="onGridReady($event)"
/> `,
})
export class AppComponent {
columnDefs: ColDef[] = [
{ field: "athlete" },
{ field: "country" },
{ field: "sport" },
{ field: "year" },
];
theme: Theme | "legacy" = myTheme;
defaultColDef: ColDef = {
flex: 1,
filter: true,
sortable: true,
resizable: true,
};
sideBar: SideBarDef | string | string[] | boolean | null = [
"columns",
"filters-new",
];
rowData!: IOlympicData[];
constructor(private http: HttpClient) {}
onGridReady(params: GridReadyEvent<IOlympicData>) {
this.http
.get<
IOlympicData[]
>("https://www.ag-grid.com/example-assets/olympic-winners.json")
.subscribe((data) => (this.rowData = data));
}
}
const myTheme = themeQuartz.withParams({
sideBarPanelAnimationDuration: 0.3,
});
import '@angular/compiler';
import { provideHttpClient } from '@angular/common/http';
import { enableProdMode } from '@angular/core';
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
if (new URLSearchParams(window.location.search).get('prod') !== 'false') {
enableProdMode();
}
const app = bootstrapApplication(AppComponent, {
providers: [provideHttpClient()],
});
export interface IOlympicData {
athlete: string,
age: number,
country: string,
year: number,
date: string,
sport: string,
gold: number,
silver: number,
bronze: number,
total: number
} Side Bar API Copy Link
The Side Bar state can be saved and restored as part of Grid State.
The list below details all the API methods relevant to the Tool Panel.
Returns the current side bar configuration. If a shortcut was used, returns the detailed long form. |
Show/hide the entire side bar, including any visible panel and the tab buttons. |
Returns true if the side bar is visible. |
Sets the side bar position relative to the grid. Possible values are 'left' or 'right'. |
Opens a particular tool panel. Provide the ID of the tool panel to open.
Optionally, provide a parent element to attach the tool panel to. |
Closes the currently open tool panel (if any). |
Returns the ID of the currently shown tool panel if any, otherwise null. |
Returns true if the tool panel is showing, otherwise false. |
Force refreshes all tool panels by calling their refresh method. |
Gets the tool panel instance corresponding to the supplied id. |
The example below demonstrates different usages of the Tool Panel API methods. The following can be noted:
- Initially the Side Bar is not visible as
sideBar.hiddenByDefault=true. - Visibility Buttons: These toggle visibility of the Tool Panel. Note that when you make
visible=false, the entire Tool Panel is hidden including the tabs. Make sure the Tool Panel is left visible before testing the other API features so you can see the impact. - Open / Close Buttons: These open and close different Tool Panel items.
- Reset Buttons: These reset the Tool Panel to a new configuration. Notice that shortcuts are provided as configuration however
getSideBar()returns back the long form. - Position Buttons: These change the position of the Side Bar relative to the grid.
- The
get*buttons log data to the developer console.
import { Component } from "@angular/core";
import { HttpClient } from "@angular/common/http";
import { AgGridAngular } from "ag-grid-angular";
import "./style.css";
import {
AutoGroupColumnDef,
ClientSideRowModelModule,
ColDef,
ColGroupDef,
GridApi,
GridOptions,
GridReadyEvent,
ModuleRegistry,
NumberFilterModule,
SideBarDef,
TextFilterModule,
ToolPanelSizeChangedEvent,
ToolPanelVisibleChangedEvent,
enableDevValidations,
} from "ag-grid-community";
import {
ColumnsToolPanelModule,
FiltersToolPanelModule,
PivotModule,
SetFilterModule,
} from "ag-grid-enterprise";
if (process.env.NODE_ENV !== "production") {
// Enable extended validations only for development
enableDevValidations();
}
ModuleRegistry.registerModules([
NumberFilterModule,
ClientSideRowModelModule,
ColumnsToolPanelModule,
FiltersToolPanelModule,
SetFilterModule,
PivotModule,
TextFilterModule,
]);
import { IOlympicData } from "./interfaces";
@Component({
selector: "my-app",
standalone: true,
imports: [AgGridAngular],
template: `<div class="parent-div">
<div class="api-panel">
<div class="api-column">
Visibility
<button (click)="setSideBarVisible(true)">
setSideBarVisible(true)
</button>
<button (click)="setSideBarVisible(false)">
setSideBarVisible(false)
</button>
<button (click)="isSideBarVisible()">isSideBarVisible()</button>
</div>
<div class="api-column">
Open & Close
<button (click)="openToolPanel('columns')">
openToolPanel('columns')
</button>
<button (click)="openToolPanel('filters')">
openToolPanel('filters')
</button>
<button (click)="closeToolPanel()">closeToolPanel()</button>
<button (click)="getOpenedToolPanel()">getOpenedToolPanel()</button>
</div>
<div class="api-column">
Reset
<button (click)="setSideBar(['filters', 'columns'])">
setSideBar(['filters','columns'])
</button>
<button (click)="setSideBar('columns')">setSideBar('columns')</button>
<button (click)="getSideBar()">getSideBar()</button>
</div>
<div class="api-column">
Position
<button (click)="setSideBarPosition('left')">
setSideBarPosition('left')
</button>
<button (click)="setSideBarPosition('right')">
setSideBarPosition('right')
</button>
</div>
</div>
<ag-grid-angular
style="width: 100%; height: 100%;"
class="grid-div"
[columnDefs]="columnDefs"
[defaultColDef]="defaultColDef"
[autoGroupColumnDef]="autoGroupColumnDef"
[sideBar]="sideBar"
[rowData]="rowData"
(toolPanelVisibleChanged)="onToolPanelVisibleChanged($event)"
(toolPanelSizeChanged)="onToolPanelSizeChanged($event)"
(gridReady)="onGridReady($event)"
/>
</div> `,
})
export class AppComponent {
private gridApi!: GridApi<IOlympicData>;
columnDefs: ColDef[] = [
{ field: "athlete", filter: "agTextColumnFilter", minWidth: 200 },
{ field: "age" },
{ field: "country", minWidth: 200 },
{ field: "year" },
{ field: "date", minWidth: 160 },
{ field: "gold" },
{ field: "silver" },
{ field: "bronze" },
{ field: "total" },
];
defaultColDef: ColDef = {
flex: 1,
minWidth: 100,
// allow every column to be aggregated
enableValue: true,
// allow every column to be grouped
enableRowGroup: true,
// allow every column to be pivoted
enablePivot: true,
filter: true,
};
autoGroupColumnDef: AutoGroupColumnDef = {
minWidth: 200,
};
sideBar: SideBarDef | string | string[] | boolean | null = {
toolPanels: [
{
id: "columns",
labelDefault: "Columns",
labelKey: "columns",
iconKey: "columns",
toolPanel: "agColumnsToolPanel",
},
{
id: "filters",
labelDefault: "Filters",
labelKey: "filters",
iconKey: "filter",
toolPanel: "agFiltersToolPanel",
},
],
defaultToolPanel: "filters",
hiddenByDefault: true,
};
rowData!: IOlympicData[];
constructor(private http: HttpClient) {}
onToolPanelVisibleChanged(event: ToolPanelVisibleChangedEvent) {
console.log("toolPanelVisibleChanged", event);
}
onToolPanelSizeChanged(event: ToolPanelSizeChangedEvent) {
console.log("toolPanelSizeChanged", event);
}
setSideBarVisible(value: boolean) {
this.gridApi.setSideBarVisible(value);
}
isSideBarVisible() {
console.log(this.gridApi.isSideBarVisible());
}
openToolPanel(key: string) {
this.gridApi.openToolPanel(key);
}
closeToolPanel() {
this.gridApi.closeToolPanel();
}
getOpenedToolPanel() {
console.log(this.gridApi.getOpenedToolPanel());
}
setSideBar(def: SideBarDef | string | string[] | boolean) {
this.gridApi.setGridOption("sideBar", def);
}
getSideBar() {
const sideBar = this.gridApi.getSideBar();
console.log(JSON.stringify(sideBar));
console.log(sideBar);
}
setSideBarPosition(position: "left" | "right") {
this.gridApi.setSideBarPosition(position);
}
onGridReady(params: GridReadyEvent<IOlympicData>) {
this.gridApi = params.api;
this.http
.get<
IOlympicData[]
>("https://www.ag-grid.com/example-assets/olympic-winners.json")
.subscribe((data) => (this.rowData = data));
}
}
.api-panel {
display: flex;
flex-direction: row;
flex-wrap: wrap;
font-family: Verdana, Geneva, Tahoma, sans-serif;
font-size: 13px;
}
.api-column {
padding: 0px 5px 5px;
text-align: center;
width: 215px;
max-height: 200px;
}
.api-column button {
width: 100%;
}
.api-column button:first-child {
margin-top: 5px;
}
.api-panel button {
margin: 2px;
}
.grid-div {
height: 100%;
}
.parent-div {
height: 100%;
display: grid;
grid-template-rows: auto 1fr;
}
import '@angular/compiler';
import { provideHttpClient } from '@angular/common/http';
import { enableProdMode } from '@angular/core';
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
if (new URLSearchParams(window.location.search).get('prod') !== 'false') {
enableProdMode();
}
const app = bootstrapApplication(AppComponent, {
providers: [provideHttpClient()],
});
export interface IOlympicData {
athlete: string,
age: number,
country: string,
year: number,
date: string,
sport: string,
gold: number,
silver: number,
bronze: number,
total: number
}